Crazy Eddies GUI System: CEGUI::Window Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# CEGUI::Window Class Reference

An abstract base class providing common functionality and specifying the required interface for derived classes. More...

Inheritance diagram for CEGUI::Window:

[legend]
Collaboration diagram for CEGUI::Window:

[legend]
List of all members.

## Public Member Functions
| Window (const String &type, const String &name)
| Constructor for Window base class.
virtual | ~Window (void)
| Destructor for Window base class.
const String & | getType (void) const
| return a String object holding the type name for this Window.
const String & | getName (void) const
| return a String object holding the name of this Window.
bool | isDestroyedByParent (void) const
| returns whether or not this Window is set to be destroyed when its parent is destroyed.
bool | isAlwaysOnTop (void) const
| returns whether or not this Window is an always on top (a.k.a 'topmost') Window.
bool | isDisabled (bool localOnly=false) const
| return true if the Window is currently disabled
bool | isVisible (bool localOnly=false) const
| return true if the Window is currently visible.
bool | isActive (void) const
| return true if this is the active Window (the window that receives inputs)
bool | isClippedByParent (void) const
| return true if this Window is clipped so that its rendering does not pass outside its parent windows area.
uint | getID (void) const
| return the ID code currently assigned to this Window by client code.
uint | getChildCount (void) const
| return the number of child Window objects currently attached to this Window.
bool | isChild (const String &name) const
| returns whether a Window with the specified name is currently attached to this Window as a child.
bool | isChild (uint ID) const
| returns whether at least one window with the given ID code is attached as a child.
bool | isChild (const Window *window) const
| return true if the given Window is a child of this window.
Window * | getChild (const String &name) const
| return a pointer to the child window with the specified name.
Window * | getChild (uint ID) const
| return a pointer to the first attached child window with the specified ID.
Window * | getChildAtIdx (uint idx) const
| return a pointer to the child window that is attached to 'this' at the given index.
Window * | getActiveChild (void)
| return a pointer to the Window that currently has input focus starting with this Window.
const Window * | getActiveChild (void) const
bool | isAncestor (const String &name) const
| return true if the specified Window is some ancestor of this Window
bool | isAncestor (uint ID) const
| return true if any Window with the given ID is some ancestor of this Window.
bool | isAncestor (const Window *window) const
| return true if the specified Window is some ancestor of this Window.
const Font * | getFont (bool useDefault=true) const
| return the Font object active for the Window.
const String & | getText (void) const
| return the current text for the Window
bool | inheritsAlpha (void) const
| return true if the Window inherits alpha from its parent(s).
float | getAlpha (void) const
| return the current alpha value set for this Window
float | getEffectiveAlpha (void) const
| return the effective alpha value that will be used when rendering this window, taking into account inheritance of parent window(s) alpha.
Rect | getRect (void) const
| return a Rect object that describes the Window area.
virtual Rect | getPixelRect (void) const
| return a Rect object describing the Window area in screen space.
Rect | getInnerRect (void) const
| return a Rect object describing the clipped inner area for this window.
Rect | getUnclippedPixelRect (void) const
| return a Rect object describing the Window area unclipped, in screen space.
virtual Rect | getUnclippedInnerRect (void) const
| Return a Rect object that describes, unclipped, the inner rectangle for this window. The inner rectangle is typically an area that excludes some frame or other rendering that should not be touched by subsequent rendering.
bool | isCapturedByThis (void) const
| return true if this Window has input captured.
bool | isCapturedByAncestor (void) const
| return true if a child window has captured inputs.
bool | isCapturedByChild (void) const
| return true if an ancestor window has captured inputs.
virtual bool | isHit (const Point &position) const
| check if the given position would hit this window.
Window * | getChildAtPosition (const Point &position) const
| return the child Window that is 'hit' by the given position
MetricsMode | getMetricsMode (void) const
| return the current metrics mode employed by the Window
float | getXPosition (void) const
| return the x position of the window. Interpretation of return value depends upon the metric type in use by this window.
float | getYPosition (void) const
| return the y position of the window. Interpretation of return value depends upon the metric type in use by this window.
Point | getPosition (void) const
| return the position of the window. Interpretation of return value depends upon the metric type in use by this window.
float | getWidth (void) const
| return the width of the Window. Interpretation of return value depends upon the metric type in use by this window.
float | getHeight (void) const
| return the height of the Window. Interpretation of return value depends upon the metric type in use by this window.
Size | getSize (void) const
| return the size of the Window. Interpretation of return value depends upon the metric type in use by this window.
Window * | getParent (void) const
| return the parent of this Window.
Size | getMaximumSize (void) const
| Return the current maximum size for this window.
Size | getMinimumSize (void) const
| Return the current minimum size for this window.
const Image * | getMouseCursor (bool useDefault=true) const
| Return a pointer to the mouse cursor image to use when the mouse is within this window.
Rect | getRelativeRect (void) const
| Return the window area rect in relative metrics.
Point | getRelativePosition (void) const
| Return the window position in relative metrics.
float | getRelativeXPosition (void) const
| Return the window X position in relative metrics.
float | getRelativeYPosition (void) const
| Return the window Y position in relative metrics.
Size | getRelativeSize (void) const
| Return the window size in relative metrics.
float | getRelativeWidth (void) const
| Return the window width in relative metrics.
float | getRelativeHeight (void) const
| Return the window height in relative metrics.
Rect | getAbsoluteRect (void) const
| Return the window area rect in absolute metrics.
Point | getAbsolutePosition (void) const
| Return the window position in absolute metrics.
float | getAbsoluteXPosition (void) const
| Return the window X position in absolute metrics.
float | getAbsoluteYPosition (void) const
| Return the window Y position in absolute metrics.
Size | getAbsoluteSize (void) const
| Return the window size in absolute metrics.
float | getAbsoluteWidth (void) const
| Return the window width in absolute metrics.
float | getAbsoluteHeight (void) const
| Return the window height in absolute metrics.
void * | getUserData (void) const
| Return the user data set for this Window.
float | getXPosition (MetricsMode mode) const
| return the x position of the window using the specified metrics system.
float | getYPosition (MetricsMode mode) const
| return the y position of the window using the specified metrics system.
Point | getPosition (MetricsMode mode) const
| return the position of the window using the specified metrics system.
float | getWidth (MetricsMode mode) const
| return the width of the Window using the specified metrics system.
float | getHeight (MetricsMode mode) const
| return the height of the Window using the specified metrics system.
Size | getSize (MetricsMode mode) const
| return the size of the Window using the specified metrics system.
Rect | getRect (MetricsMode mode) const
| return a Rect object that describes the Window area using the specified metrics system.
bool | restoresOldCapture (void) const
| Return whether this window is set to restore old input capture when it loses input capture.
bool | isZOrderingEnabled (void) const
| Return whether z-order changes are enabled or disabled for this Window.
bool | wantsMultiClickEvents (void) const
| Return whether this window will receive multi-click events or multiple 'down' events instead.
bool | isMouseAutoRepeatEnabled (void) const
| Return whether mouse button down event autorepeat is enabled for this window.
float | getAutoRepeatDelay (void) const
| Return the current auto-repeat delay setting for this window.
float | getAutoRepeatRate (void) const
| Return the current auto-repeat rate setting for this window.
bool | distributesCapturedInputs (void) const
| Return whether the window wants inputs passed to its attached child windows when the window has inputs captured.
bool | isUsingDefaultTooltip (void) const
| Return whether this Window is using the system default Tooltip for its Tooltip window.
Tooltip * | getTooltip (void) const
| Return a pointer to the Tooltip object used by this Window. The value returned may point to the system default Tooltip, a custom Window specific Tooltip, or be NULL.
String | getTooltipType (void) const
| Return the custom tooltip type.
const String & | getTooltipText (void) const
| Return the current tooltip text set for this Window.
bool | inheritsTooltipText (void) const
| Return whether this window inherits Tooltip text from its parent when its own tooltip text is not set.
bool | isRiseOnClickEnabled (void) const
| Return whether this window will rise to the top of the z-order when clicked with the left mouse button.
bool | testClassName (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
VerticalAlignment | getVerticalAlignment () const
| Get the vertical alignment.
HorizontalAlignment | getHorizontalAlignment () const
| Get the horizontal alignment.
RenderCache & | getRenderCache ()
| Return the RenderCache object for this Window.
const String & | getLookNFeel ()
| Get the name of the LookNFeel assigned to this window.
bool | getModalState (void) const
| Get whether or not this Window is the modal target.
const String & | getUserString (const String &name) const
| Returns a named user string.
bool | isUserStringDefined (const String &name) const
| Return whether a user string with the specified name exists.
Window * | getActiveSibling ()
| Returns the active sibling window.
void | rename (const String &new_name)
| Renames the window.
virtual void | initialise (void)
| Initialises the Window based object ready for use.
void | setDestroyedByParent (bool setting)
| Set whether or not this Window will automatically be destroyed when its parent Window is destroyed.
void | setAlwaysOnTop (bool setting)
| Set whether this window is always on top, or not.
void | setEnabled (bool setting)
| Set whether this window is enabled or disabled. A disabled window normally can not be interacted with, and may have different rendering.
void | enable (void)
| enable the Window to allow interaction.
void | disable (void)
| disable the Window to prevent interaction.
void | setVisible (bool setting)
| Set whether the Window is visible or hidden.
void | show (void)
| show the Window
void | hide (void)
| hide the Window.
void | activate (void)
| Activate the Window giving it input focus and bringing it to the top of all non always-on-top Windows.
void | deactivate (void)
| Deactivate the window. No further inputs will be received by the window until it is re-activated either programmatically or by the user interacting with the gui.
void | setClippedByParent (bool setting)
| Set whether this Window will be clipped by its parent window(s).
void | setID (uint ID)
| Set the current ID for the Window.
void | setText (const String &text)
| Set the current text string for the Window.
void | setWidth (float width)
| Set the current width of the Window. Interpretation of the input value width is dependant upon the current metrics system set for the Window.
void | setHeight (float height)
| Set the current height of the Window. Interpretation of the input value height is dependant upon the current metrics system set for the Window.
void | setSize (const Size &size)
| Set the current size of the Window. Interpretation of the input value size is dependant upon the current metrics system set for the Window.
void | setXPosition (float x)
| Set the current 'x' position of the Window. Interpretation of the input value x is dependant upon the current metrics system set for the Window.
void | setYPosition (float y)
| Set the current 'y' position of the Window. Interpretation of the input value y is dependant upon the current metrics system set for the Window.
void | setPosition (const Point &position)
| Set the current position of the Window. Interpretation of the input value position is dependant upon the current metrics system set for the Window.
void | setAreaRect (const Rect &area)
| Set the current area for the Window, this allows for setting of position and size at the same time. Interpretation of the input value area is dependant upon the current metrics system set for the Window.
void | setFont (const Font *font)
| Set the font used by this Window.
void | setFont (const String &name)
| Set the font used by this Window.
void | addChildWindow (const String &name)
| Add the named Window as a child of this Window. If the Window name is already attached to a Window, it is detached before being added to this Window.
void | addChildWindow (Window *window)
| Add the specified Window as a child of this Window. If the Window window is already attached to a Window, it is detached before being added to this Window.
void | removeChildWindow (const String &name)
| Remove the named Window from this windows child list.
void | removeChildWindow (Window *window)
| Remove the specified Window form this windows child list.
void | removeChildWindow (uint ID)
| Remove the first child Window with the specified ID. If there is more than one attached Window objects with the specified ID, only the fist one encountered will be removed.
void | moveToFront ()
| Move the Window to the top of the z order.
void | moveToBack ()
| Move the Window to the bottom of the Z order.
bool | captureInput (void)
| Captures input to this window.
void | releaseInput (void)
| Releases input capture from this Window. If this Window does not have inputs captured, nothing happens.
void | setRestoreCapture (bool setting)
| Set whether this window will remember and restore the previous window that had inputs captured.
void | setAlpha (float alpha)
| Set the current alpha value for this window.
void | setInheritsAlpha (bool setting)
| Sets whether this Window will inherit alpha from its parent windows.
void | requestRedraw (void) const
| Signal the System object to redraw (at least) this Window on the next render cycle.
void | setMetricsMode (MetricsMode mode)
| set the current metrics mode employed by the Window
void | setMinimumSize (const Size &sz)
| Set the minimum size for this window.
void | setMaximumSize (const Size &sz)
| Set the maximum size for this window.
void | setMouseCursor (const Image *image)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setMouseCursor (MouseCursorImage image)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setMouseCursor (const String &imageset, const String &image_name)
| Set the mouse cursor image to be used when the mouse enters this window.
void | setUserData (void *user_data)
| Set the user data set for this Window.
void | setXPosition (MetricsMode mode, float x)
| set the x position of the window using the specified metrics system.
void | setYPosition (MetricsMode mode, float y)
| set the y position of the window using the specified metrics system.
void | setPosition (MetricsMode mode, const Point &position)
| set the position of the window using the specified metrics system.
void | setWidth (MetricsMode mode, float width)
| set the width of the Window using the specified metrics system.
void | setHeight (MetricsMode mode, float height)
| set the height of the Window using the specified metrics system.
void | setSize (MetricsMode mode, const Size &size)
| set the size of the Window using the specified metrics system.
void | setRect (MetricsMode mode, const Rect &area)
| set the Rect that describes the Window area using the specified metrics system.
void | setZOrderingEnabled (bool setting)
| Set whether z-order changes are enabled or disabled for this Window.
void | setWantsMultiClickEvents (bool setting)
| Set whether this window will receive multi-click events or multiple 'down' events instead.
void | setMouseAutoRepeatEnabled (bool setting)
| Set whether mouse button down event autorepeat is enabled for this window.
void | setAutoRepeatDelay (float delay)
| Set the current auto-repeat delay setting for this window.
void | setAutoRepeatRate (float rate)
| Set the current auto-repeat rate setting for this window.
void | setDistributesCapturedInputs (bool setting)
| Set whether the window wants inputs passed to its attached child windows when the window has inputs captured.
void | notifyDragDropItemEnters (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
void | notifyDragDropItemLeaves (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
void | notifyDragDropItemDropped (DragContainer *item)
| Internal support method for drag & drop. You do not normally call this directly from client code. See the DragContainer class.
virtual void | destroy (void)
| Internal destroy method which actually just adds the window and any parent destructed child windows to the dead pool.
void | setTooltip (Tooltip *tooltip)
| Set the custom Tooltip object for this Window. This value may be NULL to indicate that the Window should use the system default Tooltip object.
void | setTooltipType (const String &tooltipType)
| Set the custom Tooltip to be used by this Window by specifying a Window type.
void | setTooltipText (const String &tip)
| Set the tooltip text for this window.
void | setInheritsTooltipText (bool setting)
| Set whether this window inherits Tooltip text from its parent when its own tooltip text is not set.
void | setRiseOnClickEnabled (bool setting)
| Set whether this window will rise to the top of the z-order when clicked with the left mouse button.
void | setVerticalAlignment (const VerticalAlignment alignment)
| Set the vertical alignment.
void | setHorizontalAlignment (const HorizontalAlignment alignment)
| Set the horizontal alignment.
void | setLookNFeel (const String &falagardType, const String &look)
| Set the LookNFeel that shoule be used for this window.
void | setModalState (bool state)
| Set the modal state for this Window.
virtual void | performChildWindowLayout ()
| method called to perform extended laying out of attached child windows.
void | setUserString (const String &name, const String &value)
| Sets the value a named user string, creating it as required.
float | absoluteToRelativeX (float val) const
| Convert the given X co-ordinate from absolute to relative metrics.
float | absoluteToRelativeY (float val) const
| Convert the given Y co-ordinate from absolute to relative metrics.
Point | absoluteToRelative (const Point &pt) const
| Convert the given position from absolute to relative metrics.
Size | absoluteToRelative (const Size &sze) const
| Convert the given size from absolute to relative metrics.
Rect | absoluteToRelative (const Rect &rect) const
| Convert the given area from absolute to relative metrics.
float | relativeToAbsoluteX (float val) const
| Convert the given X co-ordinate from relative to absolute metrics.
float | relativeToAbsoluteY (float val) const
| Convert the given Y co-ordinate from relative to absolute metrics.
Point | relativeToAbsolute (const Point &pt) const
| Convert the given position from relative to absolute metrics.
Size | relativeToAbsolute (const Size &sze) const
| Convert the given size from relative to absolute metrics.
Rect | relativeToAbsolute (const Rect &rect) const
| Convert the given area from relative to absolute metrics.
float | windowToScreenX (float x) const
| Convert a window co-ordinate value, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate.
float | windowToScreenY (float y) const
| Convert a window co-ordinate value, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate.
Point | windowToScreen (const Point &pt) const
| Convert a window co-ordinate position, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate position.
Size | windowToScreen (const Size &sze) const
| Convert a window size value, specified in whichever metrics mode is active, to a size in pixels.
Rect | windowToScreen (const Rect &rect) const
| Convert a window area, specified in whichever metrics mode is active, to a screen area.
float | screenToWindowX (float x) const
| Convert a screen relative pixel co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active.
float | screenToWindowY (float y) const
| Convert a screen relative pixel co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active.
Point | screenToWindow (const Point &pt) const
| Convert a screen relative pixel position to a window co-ordinate position, specified in whichever metrics mode is active.
Size | screenToWindow (const Size &sze) const
| Convert a pixel screen size to a window based size, specified in whichever metrics mode is active.
Rect | screenToWindow (const Rect &rect) const
| Convert a screen area to a window area, specified in whichever metrics mode is active.
float | unifiedToRelativeX (const UDim &val) const
| Convert the given X co-ordinate from unified to relative metrics.
float | unifiedToRelativeY (const UDim &val) const
| Convert the given Y co-ordinate from unified to relative metrics.
Vector2 | unifiedToRelative (const UVector2 &val) const
| Convert the given UVector2 value from unified to relative metrics.
Rect | unifiedToRelative (const URect &val) const
| Convert the given area from unfied to relative metrics.
float | unifiedToAbsoluteX (const UDim &val) const
| Convert the given X co-ordinate from unified to absolute metrics.
float | unifiedToAbsoluteY (const UDim &val) const
| Convert the given Y co-ordinate from unified to absolute metrics.
Vector2 | unifiedToAbsolute (const UVector2 &val) const
| Convert the given UVector2 value from unified to absolute metrics.
Rect | unifiedToAbsolute (const URect &val) const
| Convert the given area from unfied to absolute metrics.
float | windowToScreenX (const UDim &x) const
| Convert a window co-ordinate value, specified as a UDim, to a screen relative pixel co-ordinate.
float | windowToScreenY (const UDim &y) const
| Convert a window co-ordinate value, specified as a UDim, to a screen relative pixel co-ordinate.
Vector2 | windowToScreen (const UVector2 &vec) const
| Convert a window co-ordinate point, specified as a UVector2, to a screen relative pixel co-ordinate point.
Rect | windowToScreen (const URect &rect) const
| Convert a window area, specified as a URect, to a screen area.
float | screenToWindowX (const UDim &x) const
| Convert a screen relative UDim co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active.
float | screenToWindowY (const UDim &y) const
| Convert a screen relative UDim co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active.
Vector2 | screenToWindow (const UVector2 &vec) const
| Convert a screen relative UVector2 point to a window co-ordinate point, specified in whichever metrics mode is active.
Rect | screenToWindow (const URect &rect) const
| Convert a URect screen area to a window area, specified in whichever metrics mode is active.
void | setWindowArea (const UDim &xpos, const UDim &ypos, const UDim &width, const UDim &height)
| Set the window area.
void | setWindowArea (const UVector2 &pos, const UVector2 &size)
| Set the window area.
void | setWindowArea (const URect &area)
| Set the window area.
void | setWindowPosition (const UVector2 &pos)
| Set the window's position.
void | setWindowXPosition (const UDim &x)
| Set the window's X position.
void | setWindowYPosition (const UDim &y)
| Set the window's Y position.
void | setWindowSize (const UVector2 &size)
| Set the window's size.
void | setWindowWidth (const UDim &width)
| Set the window's width.
void | setWindowHeight (const UDim &height)
| Set the window's height.
void | setWindowMaxSize (const UVector2 &size)
| Set the window's maximum size.
void | setWindowMinSize (const UVector2 &size)
| Set the window's minimum size.
const URect & | getWindowArea () const
| Return the windows area.
const UVector2 & | getWindowPosition () const
| Get the window's position.
const UDim & | getWindowXPosition () const
| Get the window's X position.
const UDim & | getWindowYPosition () const
| Get the window's Y position.
UVector2 | getWindowSize () const
| Get the window's size.
UDim | getWindowWidth () const
| Get the window's width.
UDim | getWindowHeight () const
| Get the window's height.
const UVector2 & | getWindowMaxSize () const
| Get the window's maximum size.
const UVector2 & | getWindowMinSize () const
| Get the window's minimum size.
void | render (void)
| Causes the Window object to render itself and all of it's attached children.
void | update (float elapsed)
| Cause window to update itself and any attached children. Client code does not need to call this method; to ensure full, and proper updates, call the injectTimePulse methodname method provided by the System class.
virtual void | writeXMLToStream (OutStream &out_stream) const
| Writes an xml representation of this window object to out_stream.
## Static Public Member Functions
static Window * | getCaptureWindow (void)
| return the Window that currently has inputs captured.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const String | EventParentSized
| Parent of this Window has been re-sized.
static const String | EventSized
| Window size has changed.
static const String | EventMoved
| Window position has changed.
static const String | EventTextChanged
| Text string for the Window has changed.
static const String | EventFontChanged
| Font object for the Window has been changed.
static const String | EventAlphaChanged
| Alpha blend value for the Window has changed.
static const String | EventIDChanged
| Client assigned ID code for the Window has changed.
static const String | EventActivated
| Window has been activated (has input focus).
static const String | EventDeactivated
| Window has been deactivated (loses input focus).
static const String | EventShown
| Window has been made visible.
static const String | EventHidden
| Window has been hidden from view.
static const String | EventEnabled
| Window has been enabled (interaction is possible).
static const String | EventDisabled
| Window has been disabled (interaction is no longer possible).
static const String | EventMetricsModeChanged
| Active metrics mode has been modified.
static const String | EventClippedByParentChanged
| Clipping by parent mode has been modified.
static const String | EventDestroyedByParentChanged
| Destruction by parent mode has been modified.
static const String | EventInheritsAlphaChanged
| Alpha inherited from parent mode has been modified.
static const String | EventAlwaysOnTopChanged
| Always on top mode has been modified.
static const String | EventInputCaptureGained
| Window has captured all inputs.
static const String | EventInputCaptureLost
| Window has lost it's capture on inputs.
static const String | EventRenderingStarted
| Rendering of the Window has started.
static const String | EventRenderingEnded
| Rendering for the Window has finished.
static const String | EventChildAdded
| A child Window has been added.
static const String | EventChildRemoved
| A child window has been removed.
static const String | EventDestructionStarted
| Destruction of the Window is about to begin.
static const String | EventZOrderChanged
| The z-order of the window has changed.
static const String | EventDragDropItemEnters
| A DragContainer has been dragged over this window.
static const String | EventDragDropItemLeaves
| A DragContainer has left this window.
static const String | EventDragDropItemDropped
| A DragContainer was dropped on this Window.
static const String | EventVerticalAlignmentChanged
| The vertical alignment of the window has changed.
static const String | EventHorizontalAlignmentChanged
| The vertical alignment of the window has changed.
static const String | EventMouseEnters
| Mouse cursor has entered the Window.
static const String | EventMouseLeaves
| Mouse cursor has left the Window.
static const String | EventMouseMove
| Mouse cursor was moved within the area of the Window.
static const String | EventMouseWheel
| Mouse wheel was scrolled within the Window.
static const String | EventMouseButtonDown
| A mouse button was pressed down within the Window.
static const String | EventMouseButtonUp
| A mouse button was released within the Window.
static const String | EventMouseClick
| A mouse button was clicked (down then up) within the Window.
static const String | EventMouseDoubleClick
| A mouse button was double-clicked within the Window.
static const String | EventMouseTripleClick
| A mouse button was triple-clicked within the Window.
static const String | EventKeyDown
| A key on the keyboard was pressed.
static const String | EventKeyUp
| A key on the keyboard was released.
static const String | EventCharacterKey
| A text character was typed on the keyboard.
## Protected Types
typedef std::vector< Window * > | ChildList
typedef std::map< String, String > | UserStringMap
## Protected Member Functions
virtual void | onSized (WindowEventArgs &e)
| Handler called when the window's size changes.
virtual void | onMoved (WindowEventArgs &e)
| Handler called when the window's position changes.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
virtual void | onFontChanged (WindowEventArgs &e)
| Handler called when the window's font is changed.
virtual void | onAlphaChanged (WindowEventArgs &e)
| Handler called when the window's alpha blend value is changed.
virtual void | onIDChanged (WindowEventArgs &e)
| Handler called when the window's client assigned ID is changed.
virtual void | onShown (WindowEventArgs &e)
| Handler called when the window is shown (made visible).
virtual void | onHidden (WindowEventArgs &e)
| Handler called when the window is hidden.
virtual void | onEnabled (WindowEventArgs &e)
| Handler called when the window is enabled.
virtual void | onDisabled (WindowEventArgs &e)
| Handler called when the window is disabled.
virtual void | onMetricsChanged (WindowEventArgs &e)
| Handler called when the window's active metrics system is changed.
virtual void | onClippingChanged (WindowEventArgs &e)
| Handler called when the window's setting for being clipped by it's parent is changed.
virtual void | onParentDestroyChanged (WindowEventArgs &e)
| Handler called when the window's setting for being destroyed automatically be it's parent is changed.
virtual void | onInheritsAlphaChanged (WindowEventArgs &e)
| Handler called when the window's setting for inheriting alpha-blending is changed.
virtual void | onAlwaysOnTopChanged (WindowEventArgs &e)
| Handler called when the window's always-on-top setting is changed.
virtual void | onCaptureGained (WindowEventArgs &e)
| Handler called when this window gains capture of mouse inputs.
virtual void | onCaptureLost (WindowEventArgs &e)
| Handler called when this window loses capture of mouse inputs.
virtual void | onRenderingStarted (WindowEventArgs &e)
| Handler called when rendering for this window has started.
virtual void | onRenderingEnded (WindowEventArgs &e)
| Handler called when rendering for this window has ended.
virtual void | onZChanged (WindowEventArgs &e)
| Handler called when the z-order position of this window has changed.
virtual void | onDestructionStarted (WindowEventArgs &e)
| Handler called when this window's destruction sequence has begun.
virtual void | onActivated (ActivationEventArgs &e)
| Handler called when this window has become the active window.
virtual void | onDeactivated (ActivationEventArgs &e)
| Handler called when this window has lost input focus and has been deactivated.
virtual void | onParentSized (WindowEventArgs &e)
| Handler called when this window's parent window has been resized. If this window is the root / GUI Sheet window, this call will be made when the screen size changes.
virtual void | onChildAdded (WindowEventArgs &e)
| Handler called when a child window is added to this window.
virtual void | onChildRemoved (WindowEventArgs &e)
| Handler called when a child window is removed from this window.
virtual void | onMouseEnters (MouseEventArgs &e)
| Handler called when the mouse cursor has entered this window's area.
virtual void | onMouseLeaves (MouseEventArgs &e)
| Handler called when the mouse cursor has left this window's area.
virtual void | onMouseMove (MouseEventArgs &e)
| Handler called when the mouse cursor has been moved within this window's area.
virtual void | onMouseWheel (MouseEventArgs &e)
| Handler called when the mouse wheel (z-axis) position changes within this window's area.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseButtonUp (MouseEventArgs &e)
| Handler called when a mouse button has been released within this window's area.
virtual void | onMouseClicked (MouseEventArgs &e)
| Handler called when a mouse button has been clicked (that is depressed and then released, within a specified time) within this window's area.
virtual void | onMouseDoubleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been double-clicked within this window's area.
virtual void | onMouseTripleClicked (MouseEventArgs &e)
| Handler called when a mouse button has been triple-clicked within this window's area.
virtual void | onKeyDown (KeyEventArgs &e)
| Handler called when a key as been depressed while this window has input focus.
virtual void | onKeyUp (KeyEventArgs &e)
| Handler called when a key as been released while this window has input focus.
virtual void | onCharacter (KeyEventArgs &e)
| Handler called when a character-key has been pressed while this window has input focus.
virtual void | onDragDropItemEnters (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onDragDropItemLeaves (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onDragDropItemDropped (DragDropEventArgs &e)
| Handler called when a DragContainer is dragged over this window.
virtual void | onVerticalAlignmentChanged (WindowEventArgs &e)
| Handler called when the vertical alignment setting for the window is changed.
virtual void | onHorizontalAlignmentChanged (WindowEventArgs &e)
| Handler called when the horizontal alignment setting for the window is changed.
virtual void | updateSelf (float elapsed)
| Perform actual update processing for this Window.
virtual void | drawSelf (float z)
| Perform the actual rendering for this Window.
virtual void | populateRenderCache ()
| Update the rendering cache.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
void | setParent (Window *parent)
| Set the parent window for this window object.
float | getParentWidth (void) const
| Return the pixel Width of the parent element. This always returns a valid number.
float | getParentHeight (void) const
| Return the pixel Height of the parent element. This always returns a valid number.
Size | getParentSize (void) const
| Return the pixel size of the parent element. This always returns a valid object.
Rect | absoluteToRelative_impl (const Window *window, const Rect &rect) const
| Return a Rect object that describes, in values relative to window, the absolute area described by rect.
Size | absoluteToRelative_impl (const Window *window, const Size &sz) const
Point | absoluteToRelative_impl (const Window *window, const Point &pt) const
float | absoluteToRelativeX_impl (const Window *window, float x) const
float | absoluteToRelativeY_impl (const Window *window, float y) const
Rect | relativeToAbsolute_impl (const Window *window, const Rect &rect) const
| Return a Rect object that describes, in absolute values offset from window, the relative area described by rect.
Size | relativeToAbsolute_impl (const Window *window, const Size &sz) const
Point | relativeToAbsolute_impl (const Window *window, const Point &pt) const
float | relativeToAbsoluteX_impl (const Window *window, float x) const
float | relativeToAbsoluteY_impl (const Window *window, float y) const
Size | getWindowSize_impl (const Window *window) const
MetricsMode | getInheritedMetricsMode (void) const
| Return the inherited metrics mode. This is either the metrics mode of our parent, or Relative if we have no parent.
void | generateAutoRepeatEvent (MouseButton button)
| Fires off a repeated mouse button down event for this window.
void | addStandardEvents (void)
| Add standard CEGUI::Window events.
virtual void | cleanupChildren (void)
| Cleanup child windows.
virtual void | addChild_impl (Window *wnd)
| Add given window to child list at an appropriate position.
virtual void | removeChild_impl (Window *wnd)
| Remove given window from child list.
virtual void | onZChange_impl (void)
| Notify 'this' and all siblings of a ZOrder change event.
void | addStandardProperties (void)
| Add standard CEGUI::Window properties.
virtual void | moveToFront_impl (bool wasClicked)
| Implements move to fron behavior.
void | doRiseOnClick (void)
| Implementation of rise on click functionality.
void | setWindowArea_impl (const UVector2 &pos, const UVector2 &size, bool topLeftSizing=false, bool fireEvents=true)
| Implementation method to modify window area while correctly applying min / max size processing, and firing any appropriate events.
void | addWindowToDrawList (Window &wnd, bool at_back=false)
| Add the given window to the drawing list at an appropriate position for it's settings and the required direction. Basically, when at_back is false, the window will appear in front of all other windows with the same 'always on top' setting. When at_back is true, the window will appear behind all other windows wih the same 'always on top' setting.
void | removeWindowFromDrawList (const Window &wnd)
| Removes the window from the drawing list. If the window is not attached to the drawing list then nothing happens.
virtual int | writePropertiesXML (OutStream &out_stream) const
virtual int | writeChildWindowsXML (OutStream &out_stream) const
| Window (const Window &wnd)
Window & | operator= (const Window &wnd)
## Protected Attributes
ChildList | d_children
| The list of child Window objects attached to this.
ChildList | d_drawList
| Child window objects arranged in rendering order.
MetricsMode | d_metricsMode
| Holds the active metrics mode for this window.
Window * | d_oldCapture
| The Window that previously had capture (used for restoreOldCapture mode).
Window * | d_parent
| Holds pointer to the parent window.
const Font * | d_font
| Holds pointer to the Window objects current Font.
String | d_text
| Holds the text / label / caption for this Window.
uint | d_ID
| User ID assigned to this Window.
float | d_alpha
| Alpha transparency setting for the Window.
URect | d_area
| This Window objects area as defined by a URect.
Size | d_pixelSize
| Current constrained pixel size of the window.
const Image * | d_mouseCursor
| Holds pointer to the Window objects current mouse cursor image.
void * | d_userData
| Holds pointer to some user assigned data.
UserStringMap | d_userStrings
| Holds a collection of named user string values.
HorizontalAlignment | d_horzAlign
| Specifies the base for horizontal alignment.
VerticalAlignment | d_vertAlign
| Specifies the base for vertical alignment.
UVector2 | d_minSize
| current minimum size for the window.
UVector2 | d_maxSize
| current maximum size for the window.
bool | d_enabled
| true when Window is enabled
bool | d_visible
| true when Window is visible (that is it will be rendered, but may be obscured so no necesarily really visible)
bool | d_active
| true when Window is the active Window (receiving inputs).
bool | d_clippedByParent
| true when Window will be clipped by parent Window area Rect.
bool | d_destroyedByParent
| true when Window will be auto-destroyed by parent.
bool | d_alwaysOnTop
| true if Window will be drawn on top of all other Windows
bool | d_inheritsAlpha
| true if the Window inherits alpha from the parent Window
bool | d_restoreOldCapture
| true if the Window restores capture to the previous window when it releases capture.
bool | d_zOrderingEnabled
| true if the Window responds to z-order change requests.
bool | d_wantsMultiClicks
| true if the Window wishes to hear about multi-click mouse events.
bool | d_distCapturedInputs
| true if unhandled captured inputs should be distributed to child windows.
bool | d_riseOnClick
| True if the window should come to the front of the z order in respose to a left mouse button down event.
bool | d_autoRepeat
| true if button will auto-repeat mouse button down events while mouse button is held down,
float | d_repeatDelay
| seconds before first repeat event is fired
float | d_repeatRate
| secons between further repeats after delay has expired.
bool | d_repeating
| implements repeating - is true after delay has elapsed,
float | d_repeatElapsed
| implements repeating - tracks time elapsed.
MouseButton | d_repeatButton
| Button we're tracking (implication of this is that we only support one button at a time).
String | d_tooltipText
| Text string used as tip for this window.
Tooltip * | d_customTip
| Possible custom Tooltip for this window.
bool | d_weOwnTip
| true if this Window created the custom Tooltip.
bool | d_inheritsTipText
| true if the Window inherits tooltip text from its parent (when none set for itself).
RenderCache | d_renderCache
| Object which acts as a cache for Images to be drawn by this Window.
bool | d_needsRedraw
| true if window image cache needs to be regenerated.
String | d_lookName
| Name of the Look assigned to this window (if any).
const String | d_type
| String holding the type name for the Window (is also the name of the WindowFactory that created us).
String | d_name
| The name of the window (GUI system unique).
String | d_falagardType
| Type name of the window as defined in a Falagard mapping.
## Static Protected Attributes
static Window * | d_captureWindow = NULL
| Window that has captured inputs.
static WindowProperties::AbsoluteHeight | d_absHeightProperty
static WindowProperties::AbsoluteMaxSize | d_absMaxSizeProperty
static WindowProperties::AbsoluteMinSize | d_absMinSizeProperty
static WindowProperties::AbsolutePosition | d_absPositionProperty
static WindowProperties::AbsoluteRect | d_absRectProperty
static WindowProperties::AbsoluteSize | d_absSizeProperty
static WindowProperties::AbsoluteWidth | d_absWidthProperty
static WindowProperties::AbsoluteXPosition | d_absXPosProperty
static WindowProperties::AbsoluteYPosition | d_absYPosProperty
static WindowProperties::Alpha | d_alphaProperty
static WindowProperties::AlwaysOnTop | d_alwaysOnTopProperty
static WindowProperties::ClippedByParent | d_clippedByParentProperty
static WindowProperties::DestroyedByParent | d_destroyedByParentProperty
static WindowProperties::Disabled | d_disabledProperty
static WindowProperties::Font | d_fontProperty
static WindowProperties::Height | d_heightProperty
static WindowProperties::ID | d_IDProperty
static WindowProperties::InheritsAlpha | d_inheritsAlphaProperty
static WindowProperties::MetricsMode | d_metricsModeProperty
static WindowProperties::MouseCursorImage | d_mouseCursorProperty
static WindowProperties::Position | d_positionProperty
static WindowProperties::Rect | d_rectProperty
static WindowProperties::RelativeHeight | d_relHeightProperty
static WindowProperties::RelativeMaxSize | d_relMaxSizeProperty
static WindowProperties::RelativeMinSize | d_relMinSizeProperty
static WindowProperties::RelativePosition | d_relPositionProperty
static WindowProperties::RelativeRect | d_relRectProperty
static WindowProperties::RelativeSize | d_relSizeProperty
static WindowProperties::RelativeWidth | d_relWidthProperty
static WindowProperties::RelativeXPosition | d_relXPosProperty
static WindowProperties::RelativeYPosition | d_relYPosProperty
static WindowProperties::RestoreOldCapture | d_restoreOldCaptureProperty
static WindowProperties::Size | d_sizeProperty
static WindowProperties::Text | d_textProperty
static WindowProperties::Visible | d_visibleProperty
static WindowProperties::Width | d_widthProperty
static WindowProperties::XPosition | d_xPosProperty
static WindowProperties::YPosition | d_yPosProperty
static WindowProperties::ZOrderChangeEnabled | d_zOrderChangeProperty
static WindowProperties::WantsMultiClickEvents | d_wantsMultiClicksProperty
static WindowProperties::MouseButtonDownAutoRepeat | d_autoRepeatProperty
static WindowProperties::AutoRepeatDelay | d_autoRepeatDelayProperty
static WindowProperties::AutoRepeatRate | d_autoRepeatRateProperty
static WindowProperties::DistributeCapturedInputs | d_distInputsProperty
static WindowProperties::CustomTooltipType | d_tooltipTypeProperty
static WindowProperties::Tooltip | d_tooltipProperty
static WindowProperties::InheritsTooltipText | d_inheritsTooltipProperty
static WindowProperties::RiseOnClick | d_riseOnClickProperty
static WindowProperties::VerticalAlignment | d_vertAlignProperty
static WindowProperties::HorizontalAlignment | d_horzAlignProperty
static WindowProperties::UnifiedAreaRect | d_unifiedAreaRectProperty
static WindowProperties::UnifiedPosition | d_unifiedPositionProperty
static WindowProperties::UnifiedXPosition | d_unifiedXPositionProperty
static WindowProperties::UnifiedYPosition | d_unifiedYPositionProperty
static WindowProperties::UnifiedSize | d_unifiedSizeProperty
static WindowProperties::UnifiedWidth | d_unifiedWidthProperty
static WindowProperties::UnifiedHeight | d_unifiedHeightProperty
static WindowProperties::UnifiedMinSize | d_unifiedMinSizeProperty
static WindowProperties::UnifiedMaxSize | d_unifiedMaxSizeProperty
## Friends
class | System

## Detailed Description

An abstract base class providing common functionality and specifying the required interface for derived classes.

The Window base class is the only UI object class that the core of the system knows about, for this reason every other window, widget, or similar item within the system must be derived from Window. The base class provides the common functionality required by all UI objects, and specifies the minimal interface required to be implemented by derived classes.

## Constructor & Destructor Documentation

CEGUI::Window::Window | ( | const String & | type,
|  | const String & | name
| ) |

  | Constructor for Window base class. Parameters:
  | type | String object holding Window type (usually provided by WindowFactory).
  | name | String object holding unique name for the Window.

## Member Function Documentation

Rect CEGUI::Window::absoluteToRelative | ( | const Rect & | rect | ) | const

  | Convert the given area from absolute to relative metrics. Parameters:
  | rect | Rect object describing the area specified in pixels relative to this Window.
Returns: A Rect object describing a relative metric area that is equivalent to rect, given the Window objects current size.

Size CEGUI::Window::absoluteToRelative | ( | const Size & | sze | ) | const

  | Convert the given size from absolute to relative metrics. Parameters:
  | sze | Size object that describes a size specified in pixels.
Returns: A Size object describing a relative metric size that is equivalent to sze, given the Window objects current size.

Point CEGUI::Window::absoluteToRelative | ( | const Point & | pt | ) | const

  | Convert the given position from absolute to relative metrics. Parameters:
  | pt | Point object that describes a position specified in pixels relative to this Window (so 0,0 is this windows top-left corner).
Returns: A Point object describing a relative metric position that is equivalent to pt, given the Window objects current size.

Rect CEGUI::Window::absoluteToRelative_impl | ( | const Window * | window,
|  | const Rect & | rect
| ) | const`[protected]`

  | Return a Rect object that describes, in values relative to window, the absolute area described by rect. Parameters:
  | window | Pointer to a window object that is to be used as the base for the conversion. If this is NULL then the size of the display, as returned by the renderer object, is used.
  | rect | Rect object describing the area, in absolute values, that is to be returned as relative values.
Returns: Rect object that describes in values relative to window, the same area described as absolute values in rect.

float CEGUI::Window::absoluteToRelativeX | ( | float | val | ) | const

  | Convert the given X co-ordinate from absolute to relative metrics. Parameters:
  | val | X co-ordinate specified in pixels relative to this Window (so 0 is this windows left edge).
Returns: A relative metric value that is equivalent to val, given the Window objects current width.

float CEGUI::Window::absoluteToRelativeY | ( | float | val | ) | const

  | Convert the given Y co-ordinate from absolute to relative metrics. Parameters:
  | val | Y co-ordinate specified in pixels relative to this Window (so 0 is this windows top edge).
Returns: A relative metric value that is equivalent to val, given the Window objects current height.

void CEGUI::Window::activate | ( | void |  | ) |

| Activate the Window giving it input focus and bringing it to the top of all non always-on-top Windows. Returns: Nothing

void CEGUI::Window::addChildWindow | ( | Window * | window | ) |

  | Add the specified Window as a child of this Window. If the Window window is already attached to a Window, it is detached before being added to this Window. Parameters:
  | window | Pointer to the Window object to be added.
  Returns: Nothing Exceptions:
  | InvalidRequestException | thrown if Window window is an ancestor of this Window, to prevent cyclic Window structures.

void CEGUI::Window::addChildWindow | ( | const String & | name | ) |

  | Add the named Window as a child of this Window. If the Window name is already attached to a Window, it is detached before being added to this Window. Parameters:
  | name | String object holding the name of the Window to be added.
  Returns: Nothing. Exceptions:
  | UnknownObjectException | thrown if no Window named name exists.
  | InvalidRequestException | thrown if Window name is an ancestor of this Window, to prevent cyclic Window structures.

void CEGUI::Window::addWindowToDrawList | ( | Window & | wnd,
|  | bool | at_back = `false`
| ) | `[protected]`

  | Add the given window to the drawing list at an appropriate position for it's settings and the required direction. Basically, when at_back is false, the window will appear in front of all other windows with the same 'always on top' setting. When at_back is true, the window will appear behind all other windows wih the same 'always on top' setting. Parameters:
  | wnd | Window object to be added to the drawing list.
  | at_back | Indicates whether the window should be placed at the back of other windows in the same group. If this is false, the window is place in front of other windows in the group.
Returns: Nothing.

bool CEGUI::Window::captureInput | ( | void |  | ) |

| Captures input to this window. Returns: true if input was successfully captured to this window. false if input could not be captured to this window (maybe because the window is not active).

void CEGUI::Window::deactivate | ( | void |  | ) |

| Deactivate the window. No further inputs will be received by the window until it is re-activated either programmatically or by the user interacting with the gui. Returns: Nothing.

void CEGUI::Window::destroy | ( | void |  | ) | `[virtual]`

| Internal destroy method which actually just adds the window and any parent destructed child windows to the dead pool. This is virtual to allow for specialised cleanup which may be required in some advanced cases. If you override this for the above reason, you MUST call this base class version. Note: You never have to call this method yourself, use WindowManager to destroy your Window objects (which will call this for you).

void CEGUI::Window::disable | ( | void |  | ) | `[inline]`

| disable the Window to prevent interaction. Returns: Nothing

bool CEGUI::Window::distributesCapturedInputs | ( | void |  | ) | const

| Return whether the window wants inputs passed to its attached child windows when the window has inputs captured. Returns: true if System should pass captured input events to child windows. false if System should pass captured input events to this window only.

void CEGUI::Window::drawSelf | ( | float | z | ) | `[protected, virtual]`

  | Perform the actual rendering for this Window. Parameters:
  | z | float value specifying the base Z co-ordinate that should be used when rendering
Returns: Nothing Reimplemented in CEGUI::ButtonBase, CEGUI::DragContainer, CEGUI::GUISheet, CEGUI::ScrolledContainer, CEGUI::TabButton, and CEGUI::TabControl.

void CEGUI::Window::enable | ( | void |  | ) | `[inline]`

| enable the Window to allow interaction. Returns: Nothing

float CEGUI::Window::getAbsoluteHeight | ( | void |  | ) | const`[inline]`

| Return the window height in absolute metrics. Returns: float value describing this windows height in absolute metrics.

Point CEGUI::Window::getAbsolutePosition | ( | void |  | ) | const`[inline]`

| Return the window position in absolute metrics. Returns: Point object describing this windows position, relative to the parent window, in absolute metrics.

Rect CEGUI::Window::getAbsoluteRect | ( | void |  | ) | const`[inline]`

| Return the window area rect in absolute metrics. Returns: Rect object describing this windows area, relative to the parent window, in absolute metrics

Size CEGUI::Window::getAbsoluteSize | ( | void |  | ) | const`[inline]`

| Return the window size in absolute metrics. Returns: Size object describing this windows size in absolute metrics.

float CEGUI::Window::getAbsoluteWidth | ( | void |  | ) | const`[inline]`

| Return the window width in absolute metrics. Returns: float value describing this windows width in absolute metrics.

float CEGUI::Window::getAbsoluteXPosition | ( | void |  | ) | const`[inline]`

| Return the window X position in absolute metrics. Returns: float value describing this windows X position, relative to the parent window, in absolute metrics.

float CEGUI::Window::getAbsoluteYPosition | ( | void |  | ) | const`[inline]`

| Return the window Y position in absolute metrics. Returns: float value describing this windows Y position, relative to the parent window, in absolute metrics.

Window * CEGUI::Window::getActiveChild | ( | void |  | ) |

| return a pointer to the Window that currently has input focus starting with this Window. Returns: Pointer to the window that is active (has input focus) starting at 'this. Will return 'this' if this Window is active and either no children are attached or if none of the attached children are active. Returns NULL if this Window (and therefore all children) are not active.

Window * CEGUI::Window::getActiveSibling | ( |  | ) |

| Returns the active sibling window. This searches the immediate children of this window's parent, and returns a pointer to the active window. The method will return this if we are the immediate child of our parent that is active. If our parent is not active, or if no immediate child of our parent is active then 0 is returned. If this window has no parent, and this window is not active then 0 is returned, else this is returned. Returns: A pointer to the immediate child window attached to our parent that is currently active, or 0 if no immediate child of our parent is active.

float CEGUI::Window::getAlpha | ( | void |  | ) | const`[inline]`

| return the current alpha value set for this Window Note: The alpha value set for any given window may or may not be the final alpha value that is used when rendering. All window objects, by default, inherit alpha from thier parent window(s) - this will blend child windows, relatively, down the line of inheritance. This behaviour can be overridden via the setInheritsAlpha() method. To return the true alpha value that will be applied when rendering, use the getEffectiveAlpha() method. Returns: the currently set alpha value for this Window. Will be between 0.0f and 1.0f.

float CEGUI::Window::getAutoRepeatDelay | ( | void |  | ) | const

| Return the current auto-repeat delay setting for this window. Returns: float value indicating the delay, in seconds, defore the first repeat mouse button down event will be triggered when autorepeat is enabled.

float CEGUI::Window::getAutoRepeatRate | ( | void |  | ) | const

| Return the current auto-repeat rate setting for this window. Returns: float value indicating the rate, in seconds, at which repeat mouse button down events will be generated after the initial delay has expired.

static Window* CEGUI::Window::getCaptureWindow | ( | void |  | ) | `[inline, static]`

| return the Window that currently has inputs captured. Returns: Pointer to the Window object that currently has inputs captured, or NULL if no Window has captured input.

Window * CEGUI::Window::getChild | ( | uint | ID | ) | const

  | return a pointer to the first attached child window with the specified ID. This function will throw an exception if no child object with the given ID is attached. This decision was made (over returning NULL if no window was found) so that client code can assume that if the call returns it has a valid window pointer. We provide the isChild() functions for checking if a given window is attached. Parameters:
  | ID | uint value specifying the ID code of the window to return a pointer to.
  Returns: Pointer to the (first) Window object attached to this window that has the ID code ID. Exceptions:
  | UnknownObjectException | thrown if no window with the ID code ID is attached to this Window.

Window * CEGUI::Window::getChild | ( | const String & | name | ) | const

  | return a pointer to the child window with the specified name. This function will throw an exception if no child object with the given name is attached. This decision was made (over returning NULL if no window was found) so that client code can assume that if the call returns it has a valid window pointer. We provide the isChild() functions for checking if a given window is attached. Parameters:
  | name | String object holding the name of the child window to return a pointer to.
  Returns: Pointer to the Window object attached to this window that has the name name. Exceptions:
  | UnknownObjectException | thrown if no window named name is attached to this Window.

Window* CEGUI::Window::getChildAtIdx | ( | uint | idx | ) | const`[inline]`

  | return a pointer to the child window that is attached to 'this' at the given index. Parameters:
  | idx | Index of the child window whos pointer should be returned. This value is not bounds checked, client code should ensure that this is less than the value returned by getChildCount().
Returns: Pointer to the child window currently attached at index position idx

Window * CEGUI::Window::getChildAtPosition | ( | const Point & | position | ) | const

  | return the child Window that is 'hit' by the given position Parameters:
  | position | Point object that describes the position to check in screen pixels
Returns: Pointer to the child Window that was hit according to the Point position, or NULL if no child window was hit.

uint CEGUI::Window::getChildCount | ( | void |  | ) | const`[inline]`

| return the number of child Window objects currently attached to this Window. Returns: uint value equal to the number of Window objects directly attached to this Window as children.

float CEGUI::Window::getEffectiveAlpha | ( | void |  | ) | const

| return the effective alpha value that will be used when rendering this window, taking into account inheritance of parent window(s) alpha. Returns: the effective alpha that will be applied to this Window when rendering. Will be between 0.0f and 1.0f.

const Font * CEGUI::Window::getFont | ( | bool | useDefault = `true` | ) | const

  | return the Font object active for the Window. Parameters:
  | useDefault | Sepcifies whether to return the default font if Window has no preference set.
Returns: Pointer to the Font being used by this Window. If the window has no assigned font, the default font is returned.

float CEGUI::Window::getHeight | ( | MetricsMode | mode | ) | const

  | return the height of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: float value that specifies the height of the Window using the specified MetricsMode.

float CEGUI::Window::getHeight | ( | void |  | ) | const

| return the height of the Window. Interpretation of return value depends upon the metric type in use by this window. Returns: float value that specifies the height of the Window. Depending upon the metrics system in use for this window, the return value will either be in pixels, or as a decimal fraction of the height of the parent Window.

HorizontalAlignment CEGUI::Window::getHorizontalAlignment | ( |  | ) | const`[inline]`

| Get the horizontal alignment. Returns the horizontal alignment for the window. This setting affects how the windows position is interpreted relative to its parent. Returns: One of the HorizontalAlignment enumerated values.

uint CEGUI::Window::getID | ( | void |  | ) | const`[inline]`

| return the ID code currently assigned to this Window by client code. Returns: uint value equal to the currently assigned ID code for this Window.

Rect CEGUI::Window::getInnerRect | ( | void |  | ) | const

| return a Rect object describing the clipped inner area for this window. Returns: Rect object that describes, in appropriately clipped screen pixel co-ordinates, the window object's inner rect area.

const String & CEGUI::Window::getLookNFeel | ( |  | ) |

| Get the name of the LookNFeel assigned to this window. Returns: String object holding the name of the look assigned to this window. Returns the empty string if no look is assigned.

Size CEGUI::Window::getMaximumSize | ( | void |  | ) | const

| Return the current maximum size for this window. Returns: Size object describing the maximum size for this window. If using absolute co-ordinates the returned object has it's values expressed as screen pixels. If using relative co-ordinates the returned object has it's values expressed as fractions of the current display size.

MetricsMode CEGUI::Window::getMetricsMode | ( | void |  | ) | const

| return the current metrics mode employed by the Window Returns: One of the values of the MectricsMode enumerated type, that describes the current metrics in use by the Window.

Size CEGUI::Window::getMinimumSize | ( | void |  | ) | const

| Return the current minimum size for this window. Returns: Size object describing the minimum size for this window. If using absolute co-ordinates the returned object has it's values expressed as screen pixels. If using relative co-ordinates the returned object has it's values expressed as fractions of the current display size.

bool CEGUI::Window::getModalState | ( | void |  | ) | const`[inline]`

| Get whether or not this Window is the modal target. Returns: Returns true if this Window is the modal target, otherwise false.

const Image * CEGUI::Window::getMouseCursor | ( | bool | useDefault = `true` | ) | const

  | Return a pointer to the mouse cursor image to use when the mouse is within this window. Parameters:
  | useDefault | Sepcifies whether to return the default font if Window has no preference set.
Returns: Pointer to the mouse cursor image that will be used when the mouse enters this window. May return NULL indicating no cursor.

const String& CEGUI::Window::getName | ( | void |  | ) | const`[inline]`

| return a String object holding the name of this Window. Returns: String object holding the unique Window name.

Window* CEGUI::Window::getParent | ( | void |  | ) | const`[inline]`

| return the parent of this Window. Returns: Pointer to the Window object that is the parent of this Window. This value can be NULL, in which case the Window is a GUI Sheet / Root.

float CEGUI::Window::getParentHeight | ( | void |  | ) | const`[protected]`

| Return the pixel Height of the parent element. This always returns a valid number. Returns: float value that is equal to the pixel height of this Window objects parent

Size CEGUI::Window::getParentSize | ( | void |  | ) | const`[protected]`

| Return the pixel size of the parent element. This always returns a valid object. Returns: Size object that describes the pixel dimensions of this Window objects parent

float CEGUI::Window::getParentWidth | ( | void |  | ) | const`[protected]`

| Return the pixel Width of the parent element. This always returns a valid number. Returns: float value that is equal to the pixel width of this Window objects parent

Rect CEGUI::Window::getPixelRect | ( | void |  | ) | const`[virtual]`

| return a Rect object describing the Window area in screen space. Returns: Rect object that describes the area covered by the Window. The values in the returned Rect are in screen pixels. The returned Rect is clipped as appropriate and depending upon the 'ClippedByParent' setting. Note: This has now been made virtual to ease some customisations that require more specialised clipping requirements.

Point CEGUI::Window::getPosition | ( | MetricsMode | mode | ) | const

  | return the position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: Point object that describes the position of the Window relative to it's parent, using the specified MetricsMode.

Point CEGUI::Window::getPosition | ( | void |  | ) | const

| return the position of the window. Interpretation of return value depends upon the metric type in use by this window. Returns: Point object that describes the position of the Window relative to it's parent, depending on the metrics system in use for this Window, the values in the Point will specify either pixels or decimal fractions of the total width and height of the parent.

Rect CEGUI::Window::getRect | ( | MetricsMode | mode | ) | const

  | return a Rect object that describes the Window area using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: Rect object that describes the area covered by the Window using the specified MetricsMode.

Rect CEGUI::Window::getRect | ( | void |  | ) | const

| return a Rect object that describes the Window area. Returns: Rect object that describes the area covered by the Window. The values in the returned Rect are in whatever form is set as the current metric type. The returned Rect is unclipped and relative to the Window objects parent.

float CEGUI::Window::getRelativeHeight | ( | void |  | ) | const`[inline]`

| Return the window height in relative metrics. Returns: float value describing this windows height in parent relative metrics.

Point CEGUI::Window::getRelativePosition | ( | void |  | ) | const`[inline]`

| Return the window position in relative metrics. Returns: Point object describing this windows position, relative to the parent window, in parent relative metrics.

Rect CEGUI::Window::getRelativeRect | ( | void |  | ) | const`[inline]`

| Return the window area rect in relative metrics. Returns: Rect object describing this windows area, relative to the parent window, in parent relative metrics.

Size CEGUI::Window::getRelativeSize | ( | void |  | ) | const`[inline]`

| Return the window size in relative metrics. Returns: Size object describing this windows size in parent relative metrics.

float CEGUI::Window::getRelativeWidth | ( | void |  | ) | const`[inline]`

| Return the window width in relative metrics. Returns: float value describing this windows width in parent relative metrics.

float CEGUI::Window::getRelativeXPosition | ( | void |  | ) | const`[inline]`

| Return the window X position in relative metrics. Returns: float value describing this windows X position, relative to the parent window, in parent relative metrics.

float CEGUI::Window::getRelativeYPosition | ( | void |  | ) | const`[inline]`

| Return the window Y position in relative metrics. Returns: float value describing this windows Y position, relative to the parent window, in parent relative metrics.

RenderCache& CEGUI::Window::getRenderCache | ( |  | ) | `[inline]`

| Return the RenderCache object for this Window. Returns: Reference to the RenderCache object for this Window.

Size CEGUI::Window::getSize | ( | MetricsMode | mode | ) | const

  | return the size of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: Size object that describes the dimensions of the Window using the specified MetricsMode.

Size CEGUI::Window::getSize | ( | void |  | ) | const

| return the size of the Window. Interpretation of return value depends upon the metric type in use by this window. Returns: Size object that describes the dimensions of the Window. Depending upon the metrics system in use for this window, the values will either be in pixels, or as decimal fractions of the width and height of the parent Window.

const String& CEGUI::Window::getText | ( | void |  | ) | const`[inline]`

| return the current text for the Window Returns: A String object that holds the current text for this Window.

Tooltip * CEGUI::Window::getTooltip | ( | void |  | ) | const

| Return a pointer to the Tooltip object used by this Window. The value returned may point to the system default Tooltip, a custom Window specific Tooltip, or be NULL. Returns: Pointer to a Tooltip based object, or NULL.

const String & CEGUI::Window::getTooltipText | ( | void |  | ) | const

| Return the current tooltip text set for this Window. Returns: String object holding the current tooltip text set for this window.

String CEGUI::Window::getTooltipType | ( | void |  | ) | const

| Return the custom tooltip type. Returns: String object holding the current custom tooltip window type, or an empty string if no custom tooltip is set.

const String & CEGUI::Window::getType | ( | void |  | ) | const

| return a String object holding the type name for this Window. Returns: String object holding the Window type.

Rect CEGUI::Window::getUnclippedInnerRect | ( | void |  | ) | const`[virtual]`

| Return a Rect object that describes, unclipped, the inner rectangle for this window. The inner rectangle is typically an area that excludes some frame or other rendering that should not be touched by subsequent rendering. Returns: Rect object that describes, in unclipped screen pixel co-ordinates, the window object's inner rect area. Reimplemented in CEGUI::ScrolledContainer, CEGUI::Static, and CEGUI::StaticText.

Rect CEGUI::Window::getUnclippedPixelRect | ( | void |  | ) | const

| return a Rect object describing the Window area unclipped, in screen space. Returns: Rect object that describes the area covered by the Window. The values in the returned Rect are in screen pixels. The returned rect is fully unclipped.

void* CEGUI::Window::getUserData | ( | void |  | ) | const`[inline]`

| Return the user data set for this Window. Each Window can have some client assigned data attached to it, this data is not used by the GUI system in any way. Interpretation of the data is entirely application specific. Returns: pointer to the user data that is currently set for this window.

const String & CEGUI::Window::getUserString | ( | const String & | name | ) | const

  | Returns a named user string. Parameters:
  | name | String object holding the name of the string to be returned.
  Returns: String object holding the data stored for the requested user string. Exceptions:
  | UnknownObjectException | thrown if a user string named name does not exist.

VerticalAlignment CEGUI::Window::getVerticalAlignment | ( |  | ) | const`[inline]`

| Get the vertical alignment. Returns the vertical alignment for the window. This setting affects how the windows position is interpreted relative to its parent. Returns: One of the VerticalAlignment enumerated values.

float CEGUI::Window::getWidth | ( | MetricsMode | mode | ) | const

  | return the width of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: float value that specifies the width of the Window using the specified MetricsMode.

float CEGUI::Window::getWidth | ( | void |  | ) | const

| return the width of the Window. Interpretation of return value depends upon the metric type in use by this window. Returns: float value that specifies the width of the Window. Depending upon the metrics system in use for this window, the return value will either be in pixels, or as a decimal fraction of the width of the parent Window.

const URect & CEGUI::Window::getWindowArea | ( |  | ) | const

| Return the windows area. Returns the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: URect describing the rectangle of the window area.

UDim CEGUI::Window::getWindowHeight | ( |  | ) | const

| Get the window's height. Gets the height of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UDim describing the height of the window area.

const UVector2 & CEGUI::Window::getWindowMaxSize | ( |  | ) | const

| Get the window's maximum size. Gets the maximum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UVector2 describing the maximum size of the window area.

const UVector2 & CEGUI::Window::getWindowMinSize | ( |  | ) | const

| Get the window's minimum size. Gets the minimum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UVector2 describing the minimum size of the window area.

const UVector2 & CEGUI::Window::getWindowPosition | ( |  | ) | const

| Get the window's position. Gets the position of the area occupied by this window. The position is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UVector2 describing the position (top-left corner) of the window area.

UVector2 CEGUI::Window::getWindowSize | ( |  | ) | const

| Get the window's size. Gets the size of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UVector2 describing the size of the window area.

UDim CEGUI::Window::getWindowWidth | ( |  | ) | const

| Get the window's width. Gets the width of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UDim describing the width of the window area.

const UDim & CEGUI::Window::getWindowXPosition | ( |  | ) | const

| Get the window's X position. Gets the x position (left edge) of the area occupied by this window. The position is offset from the left edge of this windows parent window or from the left edge of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UDim describing the x position of the window area.

const UDim & CEGUI::Window::getWindowYPosition | ( |  | ) | const

| Get the window's Y position. Gets the y position (top edge) of the area occupied by this window. The position is offset from the top edge of this windows parent window or from the top edge of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Returns: UDim describing the y position of the window area.

float CEGUI::Window::getXPosition | ( | MetricsMode | mode | ) | const

  | return the x position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: float value that specifies the x position of the Window relative to it's parent, using the specified MetricsMode.

float CEGUI::Window::getXPosition | ( | void |  | ) | const

| return the x position of the window. Interpretation of return value depends upon the metric type in use by this window. Returns: float value that specifies the x position of the Window relative to it's parent, depending on the metrics system in use for this Window, this value will specify either pixels or a decimal fraction of the width of the parent Window.

float CEGUI::Window::getYPosition | ( | MetricsMode | mode | ) | const

  | return the y position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
Returns: float value that specifies the y position of the Window relative to it's parent, using the specified MetricsMode.

float CEGUI::Window::getYPosition | ( | void |  | ) | const

| return the y position of the window. Interpretation of return value depends upon the metric type in use by this window. Returns: float value that specifies the y position of the Window relative to it's parent, depending on the metrics system in use for this Window, this value will specify either pixels or a decimal fraction of the height of the parent Window.

void CEGUI::Window::hide | ( | void |  | ) | `[inline]`

| hide the Window. Returns: Nothing

bool CEGUI::Window::inheritsAlpha | ( | void |  | ) | const`[inline]`

| return true if the Window inherits alpha from its parent(s). Returns: true if the Window inherits alpha from its parent(s), false if the alpha for this Window is independant.

bool CEGUI::Window::inheritsTooltipText | ( | void |  | ) | const

| Return whether this window inherits Tooltip text from its parent when its own tooltip text is not set. Returns: true if the window inherits tooltip text from its parent when its own text is not set. false if the window does not inherit tooltip text from its parent (and shows no tooltip when no text is set).

virtual void CEGUI::Window::initialise | ( | void |  | ) | `[inline, virtual]`

| Initialises the Window based object ready for use. Note: This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window type. Returns: Nothing Reimplemented in CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::FrameWindow, CEGUI::GUISheet, CEGUI::ItemListBase, CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::Slider, CEGUI::Spinner, CEGUI::StaticText, and CEGUI::TabControl.

bool CEGUI::Window::isActive | ( | void |  | ) | const

| return true if this is the active Window (the window that receives inputs) Mouse events are always sent to the window containing the mouse cursor regardless of what this reports (unless the window has captured inputs). This mainly refers to where other (keyboard) inputs are sent. Returns: true if this window has input focus, or false if it does not.

bool CEGUI::Window::isAlwaysOnTop | ( | void |  | ) | const`[inline]`

| returns whether or not this Window is an always on top (a.k.a 'topmost') Window. Returns: true if this Window is always show on top of other normal windows. false if the Window has normal z-order behaviour.

bool CEGUI::Window::isAncestor | ( | const Window * | window | ) | const

  | return true if the specified Window is some ancestor of this Window. Parameters:
  | window | Pointer to the Window object to look for.
Returns: true if window was found to be an ancestor (parent, or parent of parent, etc) of this Window, otherwise false.

bool CEGUI::Window::isAncestor | ( | uint | ID | ) | const

  | return true if any Window with the given ID is some ancestor of this Window. Parameters:
  | ID | uint value specifying the ID to look for.
Returns: true if an ancestor (parent, or parent of parent, etc) was found with the ID code ID, else false.

bool CEGUI::Window::isAncestor | ( | const String & | name | ) | const

  | return true if the specified Window is some ancestor of this Window Parameters:
  | name | String object holding the name of the Window to check for.
Returns: true if a Window named name is an ancestor (parent, or parent of parent, etc) of this Window, or false if not.

bool CEGUI::Window::isCapturedByAncestor | ( | void |  | ) | const`[inline]`

| return true if a child window has captured inputs. Returns: true if inputs are captured by a Window that is attached as a child of this Window, else false.

bool CEGUI::Window::isCapturedByChild | ( | void |  | ) | const`[inline]`

| return true if an ancestor window has captured inputs. Returns: true if inputs are captured by a Window that is some ancestor (parent, parent of parent, etc) of this Window, else false.

bool CEGUI::Window::isCapturedByThis | ( | void |  | ) | const`[inline]`

| return true if this Window has input captured. Returns: true if this Window has captured inputs, or false if some other Window, or no Window, has captured inputs.

bool CEGUI::Window::isChild | ( | const Window * | window | ) | const

  | return true if the given Window is a child of this window. Parameters:
  | window | Pointer to the Window object to look for.
Returns: true if Window object window is attached to this window as a child.

bool CEGUI::Window::isChild | ( | uint | ID | ) | const

  | returns whether at least one window with the given ID code is attached as a child. Note: ID codes are client assigned and may or may not be unique, and as such, the return from this function will only have meaning to the client code. Parameters:
  | ID | uint ID code to look for.
Returns: true if a child window was found with the ID code ID, or false if no child window was found with the ID ID.

bool CEGUI::Window::isChild | ( | const String & | name | ) | const

  | returns whether a Window with the specified name is currently attached to this Window as a child. Parameters:
  | name | String object containing the name of the Window to look for.
Returns: true if a Window named name is currently attached to this Window as a child, else false.

bool CEGUI::Window::isClippedByParent | ( | void |  | ) | const`[inline]`

| return true if this Window is clipped so that its rendering does not pass outside its parent windows area. Returns: true if the window will be clipped by its parent window, or false if this windows rendering may pass outside its parents area

bool CEGUI::Window::isDestroyedByParent | ( | void |  | ) | const`[inline]`

| returns whether or not this Window is set to be destroyed when its parent is destroyed. Returns: true if the Window will be destroyed when its parent is destroyed, false if it will remain.

bool CEGUI::Window::isDisabled | ( | bool | localOnly = `false` | ) | const

  | return true if the Window is currently disabled Parameters:
  | localOnly | States whether to only return the state set for this window, and so not factor in inherited state from ancestor windows.
Returns: true if the window is disabled, false if the window is enabled.

bool CEGUI::Window::isHit | ( | const Point & | position | ) | const`[virtual]`

  | check if the given position would hit this window. Parameters:
  | position | Point object describing the position to check in screen pixels
Returns: true if position 'hits' this Window, else false. Reimplemented in CEGUI::Combobox, and CEGUI::FrameWindow.

bool CEGUI::Window::isMouseAutoRepeatEnabled | ( | void |  | ) | const

| Return whether mouse button down event autorepeat is enabled for this window. Returns: true if autorepeat of mouse button down events is enabled for this window. false if autorepeat of mouse button down events is not enabled for this window.

bool CEGUI::Window::isRiseOnClickEnabled | ( | void |  | ) | const`[inline]`

| Return whether this window will rise to the top of the z-order when clicked with the left mouse button. Returns: true if the window will come to the top of other windows when the left mouse button is pushed within its area. false if the window does not change z-order position when the left mouse button is pushed within its area.

bool CEGUI::Window::isUserStringDefined | ( | const String & | name | ) | const

  | Return whether a user string with the specified name exists. Parameters:
  | name | String object holding the name of the string to be checked.
Returns: true if a user string named name exists. false if no such user string exists.

bool CEGUI::Window::isUsingDefaultTooltip | ( | void |  | ) | const

| Return whether this Window is using the system default Tooltip for its Tooltip window. Returns: true if the Window will use the system default tooltip. false if the window has a custom Tooltip object.

bool CEGUI::Window::isVisible | ( | bool | localOnly = `false` | ) | const

  | return true if the Window is currently visible. A true return from this function does not mean that the window is not completely obscured by other windows, just that the window is processed when rendering and is not hidden. Parameters:
  | localOnly | States whether to only return the state set for this window, and so not factor in inherited state from ancestor windows.
Returns: true if the window is drawn, false if the window is hidden and therefore ignored when rendering.

bool CEGUI::Window::isZOrderingEnabled | ( | void |  | ) | const

| Return whether z-order changes are enabled or disabled for this Window. Returns: true if z-order changes are enabled for this window. moveToFront/moveToBack work normally as expected. false: z-order changes are disabled for this window. moveToFront/moveToBack are ignored for this window.

void CEGUI::Window::moveToBack | ( |  | ) |

| Move the Window to the bottom of the Z order. If the window is non always-on-top the Window is sent to the very bottom of its sibling windows and the process repeated for all ancestors. If the window is always-on-top, the Window is sent to the bottom of all sibling always-on-top windows and the process repeated for all ancestors. Returns: Nothing

void CEGUI::Window::moveToFront | ( |  | ) |

| Move the Window to the top of the z order. If the Window is a non always-on-top window it is moved the the top of all other non always-on-top sibling windows, and the process repeated for all ancestors. If the Window is an always-on-top window it is moved to the of of all sibling Windows, and the process repeated for all ancestors. Returns: Nothing

void CEGUI::Window::onActivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window has become the active window. Parameters:
  | e | ActivationEventArgs class whose 'otherWindow' field is set to the window that previously was active, or NULL for none.
Reimplemented in CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::FrameWindow, and CEGUI::Spinner.

void CEGUI::Window::onAlphaChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's alpha blend value is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::DragContainer, CEGUI::PopupMenu, CEGUI::Static, and CEGUI::StaticImage.

void CEGUI::Window::onAlwaysOnTopChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's always-on-top setting is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onCaptureGained | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window gains capture of mouse inputs. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onCaptureLost | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window loses capture of mouse inputs. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::Thumb, and CEGUI::Titlebar.

void CEGUI::Window::onCharacter | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a character-key has been pressed while this window has input focus. Parameters:
  | e | KeyEventArgs object whose 'codepoint' field is set to the Unicode code point (encoded as utf32) for the character typed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.
Reimplemented in CEGUI::Editbox, and CEGUI::MultiLineEditbox.

void CEGUI::Window::onChildAdded | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a child window is added to this window. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that has been added.
Reimplemented in CEGUI::ScrolledContainer.

void CEGUI::Window::onChildRemoved | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a child window is removed from this window. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set the window that has been removed.
Reimplemented in CEGUI::ScrolledContainer.

void CEGUI::Window::onClippingChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's setting for being clipped by it's parent is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::DragContainer.

void CEGUI::Window::onDeactivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window has lost input focus and has been deactivated. Parameters:
  | e | ActivationEventArgs object whose 'otherWindow' field is set to the window that has now become active, or NULL for none.
Reimplemented in CEGUI::FrameWindow.

void CEGUI::Window::onDestructionStarted | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window's destruction sequence has begun. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onDisabled | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window is disabled. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onDragDropItemDropped | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a DragContainer is dragged over this window. Parameters:
  | e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

void CEGUI::Window::onDragDropItemEnters | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a DragContainer is dragged over this window. Parameters:
  | e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

void CEGUI::Window::onDragDropItemLeaves | ( | DragDropEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a DragContainer is dragged over this window. Parameters:
  | e | DragDropEventArgs object initialised as follows: window field is normaly set to point to 'this' window. dragDropItem is a pointer to a DragContainer window that triggered the event.

void CEGUI::Window::onEnabled | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window is enabled. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onFontChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's font is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::Combobox, CEGUI::Spinner, CEGUI::StaticText, CEGUI::TabControl, and CEGUI::Titlebar.

void CEGUI::Window::onHidden | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window is hidden. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onHorizontalAlignmentChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the horizontal alignment setting for the window is changed. Parameters:
  | e | WindowEventArgs object initialised as follows: window field is set to point to the Window object whos alignment has changed (typically 'this').

void CEGUI::Window::onIDChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's client assigned ID is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onInheritsAlphaChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's setting for inheriting alpha-blending is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onKeyDown | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a key as been depressed while this window has input focus. Parameters:
  | e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was pressed, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated.
Reimplemented in CEGUI::Editbox, and CEGUI::MultiLineEditbox.

void CEGUI::Window::onKeyUp | ( | KeyEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a key as been released while this window has input focus. Parameters:
  | e | KeyEventArgs object whose 'scancode' field is set to the Key::Scan value representing the key that was released, and whose 'sysKeys' field represents the combination of SystemKey that were active when the event was generated. All other fields should be considered as 'junk'.

void CEGUI::Window::onMetricsChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's active metrics system is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been depressed within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::Listbox, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::Scrollbar, CEGUI::Slider, CEGUI::Thumb, and CEGUI::Titlebar.

void CEGUI::Window::onMouseButtonUp | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been released within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::ButtonBase, CEGUI::Checkbox, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::PushButton, CEGUI::RadioButton, CEGUI::TabButton, and CEGUI::Titlebar.

void CEGUI::Window::onMouseClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been clicked (that is depressed and then released, within a specified time) within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.

void CEGUI::Window::onMouseDoubleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been double-clicked within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::Editbox, CEGUI::ListHeaderSegment, CEGUI::MultiLineEditbox, and CEGUI::Titlebar.

void CEGUI::Window::onMouseEnters | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse cursor has entered this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::Tooltip.

void CEGUI::Window::onMouseLeaves | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse cursor has left this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::ButtonBase, CEGUI::ListHeaderSegment, and CEGUI::MenuItem.

void CEGUI::Window::onMouseMove | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse cursor has been moved within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::ButtonBase, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::Listbox, CEGUI::ListHeaderSegment, CEGUI::MenuItem, CEGUI::MultiLineEditbox, CEGUI::Thumb, and CEGUI::Titlebar.

void CEGUI::Window::onMouseTripleClicked | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been triple-clicked within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::Editbox, and CEGUI::MultiLineEditbox.

void CEGUI::Window::onMouseWheel | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse wheel (z-axis) position changes within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented in CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::Slider, and CEGUI::StaticText.

void CEGUI::Window::onMoved | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's position changes. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onParentDestroyChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's setting for being destroyed automatically be it's parent is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onParentSized | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window's parent window has been resized. If this window is the root / GUI Sheet window, this call will be made when the screen size changes. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set the the window that caused the event; this is typically either this window's parent window, or NULL to indicate the screen size has changed.
Reimplemented in CEGUI::ScrolledContainer.

void CEGUI::Window::onRenderingEnded | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when rendering for this window has ended. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onRenderingStarted | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when rendering for this window has started. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onShown | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window is shown (made visible). Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::onSized | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's size changes. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::ItemListBase, CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::PushButton, CEGUI::ScrollablePane, CEGUI::Static, CEGUI::StaticImage, and CEGUI::StaticText.

void CEGUI::Window::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's text is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented in CEGUI::Combobox, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::MultiLineEditbox, CEGUI::Spinner, CEGUI::StaticText, CEGUI::TextItem, and CEGUI::Tooltip.

void CEGUI::Window::onVerticalAlignmentChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the vertical alignment setting for the window is changed. Parameters:
  | e | WindowEventArgs object initialised as follows: window field is set to point to the Window object whos alignment has changed (typically 'this').

void CEGUI::Window::onZChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the z-order position of this window has changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

void CEGUI::Window::performChildWindowLayout | ( |  | ) | `[virtual]`

| method called to perform extended laying out of attached child windows. The system may call this at various times (like when it is resized for example), and it may be invoked directly where required. Returns: Nothing. Reimplemented in CEGUI::TabControl.

virtual void CEGUI::Window::populateRenderCache | ( |  | ) | `[inline, protected, virtual]`

| Update the rendering cache. Populates the Window's RenderCache with imagery to be sent to the renderer. Reimplemented in CEGUI::ItemListBase, CEGUI::Listbox, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::Static, CEGUI::StaticImage, CEGUI::StaticText, and CEGUI::TextItem.

Rect CEGUI::Window::relativeToAbsolute | ( | const Rect & | rect | ) | const

  | Convert the given area from relative to absolute metrics. Parameters:
  | rect | Rect object describing the area specified in relative metrics for this Window.
Returns: A Rect object that describes an area in absolute metric values that is equivalent to rect, given the Window objects current size.

Size CEGUI::Window::relativeToAbsolute | ( | const Size & | sze | ) | const

  | Convert the given size from relative to absolute metrics. Parameters:
  | sze | Size object describing a size specified in relative metrics for this Window.
Returns: A Size object that describes a size in absolute metric values that is equivalent to sze, given the Window objects current size.

Point CEGUI::Window::relativeToAbsolute | ( | const Point & | pt | ) | const

  | Convert the given position from relative to absolute metrics. Parameters:
  | pt | Point object describing a position specified in relative metrics for this Window (so 0,0 is this windows top-left corner).
Returns: A Point object describing a position in absolute metric values that is equivalent to pt, given the Window objects current size.

Rect CEGUI::Window::relativeToAbsolute_impl | ( | const Window * | window,
|  | const Rect & | rect
| ) | const`[protected]`

  | Return a Rect object that describes, in absolute values offset from window, the relative area described by rect. Parameters:
  | window | Pointer to a window object that is to be used as the base for the conversion. If this is NULL then the size of the display, as returned by the renderer object, is used.
  | rect | Rect object describing the area, in relative values, that is to be returned as absolute values.
Returns: Rect object that describes in absolute values offset from window, the same area described as relative values in rect.

float CEGUI::Window::relativeToAbsoluteX | ( | float | val | ) | const

  | Convert the given X co-ordinate from relative to absolute metrics. Parameters:
  | val | X co-ordinate specified in relative metrics for this Window (so 0 is this windows left edge).
Returns: An absolute metric value that is equivalent to val, given the Window objects current width.

float CEGUI::Window::relativeToAbsoluteY | ( | float | val | ) | const

  | Convert the given Y co-ordinate from relative to absolute metrics. Parameters:
  | val | Y co-ordinate specified in relative metrics for this Window (so 0 is this windows top edge).
Returns: An absolute metric value that is equivalent to val, given the Window objects current height.

void CEGUI::Window::releaseInput | ( | void |  | ) |

| Releases input capture from this Window. If this Window does not have inputs captured, nothing happens. Returns: Nothing

void CEGUI::Window::removeChildWindow | ( | uint | ID | ) |

  | Remove the first child Window with the specified ID. If there is more than one attached Window objects with the specified ID, only the fist one encountered will be removed. Parameters:
  | ID | ID number assigned to the Window to be removed. If no Window with ID code ID is attached, nothing happens.
Returns: Nothing.

void CEGUI::Window::removeChildWindow | ( | Window * | window | ) |

  | Remove the specified Window form this windows child list. Parameters:
  | window | Pointer to the Window object to be removed. If the window is not attached to this Window, then nothing happens.
Returns: Nothing.

void CEGUI::Window::removeChildWindow | ( | const String & | name | ) |

  | Remove the named Window from this windows child list. Parameters:
  | name | String object holding the name of the Window to be removed. If the Window specified is not attached to this Window, nothing happens.
Returns: Nothing.

void CEGUI::Window::removeWindowFromDrawList | ( | const Window & | wnd | ) | `[protected]`

  | Removes the window from the drawing list. If the window is not attached to the drawing list then nothing happens. Parameters:
  | wnd | Window object to be removed from the drawing list.
Returns: Nothing.

void CEGUI::Window::rename | ( | const String & | new_name | ) |

  | Renames the window. Parameters:
  | new_name | String object holding the new name for the window.
  Exceptions:
  | AlreadyExistsException | thrown if a Window named new_name already exists in the system.

void CEGUI::Window::render | ( | void |  | ) |

| Causes the Window object to render itself and all of it's attached children. Returns: Nothing

void CEGUI::Window::requestRedraw | ( | void |  | ) | const

| Signal the System object to redraw (at least) this Window on the next render cycle. Returns: Nothing

bool CEGUI::Window::restoresOldCapture | ( | void |  | ) | const`[inline]`

| Return whether this window is set to restore old input capture when it loses input capture. This is only really useful for certain sub-components for widget writers. Returns: true if the window will restore the previous capture window when it loses input capture. false if the window will set the capture window to NULL when it loses input capture (this is the default behaviour).

Rect CEGUI::Window::screenToWindow | ( | const URect & | rect | ) | const

  | Convert a URect screen area to a window area, specified in whichever metrics mode is active. Parameters:
  | rect | URect object describing the area to be converted
Returns: Rect object describing a window area that is equivalent to URect screen area rect.

Vector2 CEGUI::Window::screenToWindow | ( | const UVector2 & | vec | ) | const

  | Convert a screen relative UVector2 point to a window co-ordinate point, specified in whichever metrics mode is active. Parameters:
  | vec | UVector2 object describing the point to be converted
Returns: Vector2 object describing a window co-ordinate point that is equivalent to screen based UVector2 point vec.

Rect CEGUI::Window::screenToWindow | ( | const Rect & | rect | ) | const

  | Convert a screen area to a window area, specified in whichever metrics mode is active. Parameters:
  | rect | Rect object describing the area to be converted
Returns: Rect object describing a window area that is equivalent to screen area rect.

Size CEGUI::Window::screenToWindow | ( | const Size & | sze | ) | const

  | Convert a pixel screen size to a window based size, specified in whichever metrics mode is active. Parameters:
  | sze | Size object describing the size to be converted
Returns: Size object describing a window based size that is equivalent to screen based size sze.

Point CEGUI::Window::screenToWindow | ( | const Point & | pt | ) | const

  | Convert a screen relative pixel position to a window co-ordinate position, specified in whichever metrics mode is active. Parameters:
  | pt | Point object describing the position to be converted
Returns: Point object describing a window co-ordinate position that is equivalent to screen co-ordinate x.

float CEGUI::Window::screenToWindowX | ( | const UDim & | x | ) | const

  | Convert a screen relative UDim co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active. Parameters:
  | x | UDim x co-ordinate value to be converted
Returns: float value describing a window co-ordinate value that is equivalent to screen UDim co-ordinate x.

float CEGUI::Window::screenToWindowX | ( | float | x | ) | const

  | Convert a screen relative pixel co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active. Parameters:
  | x | x co-ordinate value to be converted
Returns: float value describing a window co-ordinate value that is equivalent to screen co-ordinate x.

float CEGUI::Window::screenToWindowY | ( | const UDim & | y | ) | const

  | Convert a screen relative UDim co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active. Parameters:
  | y | UDim y co-ordinate value to be converted
Returns: float value describing a window co-ordinate value that is equivalent to screen UDim co-ordinate y.

float CEGUI::Window::screenToWindowY | ( | float | y | ) | const

  | Convert a screen relative pixel co-ordinate value to a window co-ordinate value, specified in whichever metrics mode is active. Parameters:
  | y | y co-ordinate value to be converted
Returns: float value describing a window co-ordinate value that is equivalent to screen co-ordinate y.

void CEGUI::Window::setAlpha | ( | float | alpha | ) |

  | Set the current alpha value for this window. Note: The alpha value set for any given window may or may not be the final alpha value that is used when rendering. All window objects, by default, inherit alpha from thier parent window(s) - this will blend child windows, relatively, down the line of inheritance. This behaviour can be overridden via the setInheritsAlpha() method. To return the true alpha value that will be applied when rendering, use the getEffectiveAlpha() method. Parameters:
  | alpha | The new alpha value for the window. Value should be between 0.0f and 1.0f.
Returns: Nothing

void CEGUI::Window::setAlwaysOnTop | ( | bool | setting | ) |

  | Set whether this window is always on top, or not. Parameters:
  | setting | true to have the Window appear on top of all other non always on top windows, or false to allow the window to be covered by other windows.
Returns: Nothing

void CEGUI::Window::setAreaRect | ( | const Rect & | area | ) |

  | Set the current area for the Window, this allows for setting of position and size at the same time. Interpretation of the input value area is dependant upon the current metrics system set for the Window. Parameters:
  | area | Rect object that describes the new area for Window, in units consistent with the current metrics mode.
Returns: Nothing

void CEGUI::Window::setAutoRepeatDelay | ( | float | delay | ) |

  | Set the current auto-repeat delay setting for this window. Parameters:
  | delay | float value indicating the delay, in seconds, defore the first repeat mouse button down event should be triggered when autorepeat is enabled.
Returns: Nothing.

void CEGUI::Window::setAutoRepeatRate | ( | float | rate | ) |

  | Set the current auto-repeat rate setting for this window. Parameters:
  | rate | float value indicating the rate, in seconds, at which repeat mouse button down events should be generated after the initial delay has expired.
Returns: Nothing.

void CEGUI::Window::setClippedByParent | ( | bool | setting | ) |

  | Set whether this Window will be clipped by its parent window(s). Parameters:
  | setting | true to have the Window clipped so that rendering is constrained to within the area of its parent(s), or false to have rendering constrained to the screen only.
Returns: Nothing

void CEGUI::Window::setDestroyedByParent | ( | bool | setting | ) |

  | Set whether or not this Window will automatically be destroyed when its parent Window is destroyed. Parameters:
  | setting | set to true to have the Window auto-destroyed when its parent is destroyed (default), or false to have the Window remain after its parent is destroyed.
Returns: Nothing

void CEGUI::Window::setDistributesCapturedInputs | ( | bool | setting | ) |

  | Set whether the window wants inputs passed to its attached child windows when the window has inputs captured. Parameters:
  | setting | true if System should pass captured input events to child windows. false if System should pass captured input events to this window only.

void CEGUI::Window::setEnabled | ( | bool | setting | ) |

  | Set whether this window is enabled or disabled. A disabled window normally can not be interacted with, and may have different rendering. Parameters:
  | setting | true to enable the Window, and false to disable the Window.
Returns: Nothing

void CEGUI::Window::setFont | ( | const String & | name | ) |

  | Set the font used by this Window. Parameters:
  | name | String object holding the name of the Font object to be used by this Window. If name == "", the default font will be used.
  Returns: Nothing Exceptions:
  | UnknownObjectException | thrown if the specified Font is unknown within the system.

void CEGUI::Window::setFont | ( | const Font * | font | ) |

  | Set the font used by this Window. Parameters:
  | font | Pointer to the Font object to be used by this Window. If font is NULL, the default font will be used.
Returns: Nothing

void CEGUI::Window::setHeight | ( | MetricsMode | mode,
|  | float | height
| ) |

  | set the height of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | height | float value that specifies the height of the Window using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setHeight | ( | float | height | ) |

  | Set the current height of the Window. Interpretation of the input value height is dependant upon the current metrics system set for the Window. Parameters:
  | height | float value that specifies the new height for the window, in units consistent with whatever metrics mode is in operation.
Returns: Nothing

void CEGUI::Window::setHorizontalAlignment | ( | const HorizontalAlignment | alignment | ) |

  | Set the horizontal alignment. Modifies the horizontal alignment for the window. This setting affects how the windows position is interpreted relative to its parent. Parameters:
  | alignment | One of the HorizontalAlignment enumerated values.
Returns: Nothing.

void CEGUI::Window::setID | ( | uint | ID | ) |

  | Set the current ID for the Window. Parameters:
  | ID | Client assigned ID code for this Window. The GUI system assigns no meaning to any IDs, they are a device purely for client code usage.
Returns: Nothing

void CEGUI::Window::setInheritsAlpha | ( | bool | setting | ) |

  | Sets whether this Window will inherit alpha from its parent windows. Parameters:
  | setting | true if the Window should use inherited alpha, or false if the Window should have an independant alpha value.
Returns: Nothing

void CEGUI::Window::setInheritsTooltipText | ( | bool | setting | ) |

  | Set whether this window inherits Tooltip text from its parent when its own tooltip text is not set. Parameters:
  | setting | true if the window should inherit tooltip text from its parent when its own text is not set. false if the window should not inherit tooltip text from its parent (and so show no tooltip when no text is set).
Returns: Nothing.

void CEGUI::Window::setLookNFeel | ( | const String & | falagardType,
|  | const String & | look
| ) |

  | Set the LookNFeel that shoule be used for this window. Parameters:
  | falagardType | String object holding the mapped falagard type name (since actual window type will be "Falagard/something") and not what was passed to WindowManager. This will be returned from getType instead of the base type.
  | look | String object holding the name of the look to be assigned to the window.
  Returns: Nothing. Exceptions:
  | InvalidRequestException | thrown if the window already has a look assigned to it.

void CEGUI::Window::setMaximumSize | ( | const Size & | sz | ) |

  | Set the maximum size for this window. Parameters:
  | sz | Size object describing the maximum size for the window. For absolute metrics, the Size values are in screen pixels, for relative metrics the Size values are relative to the display size.

void CEGUI::Window::setMetricsMode | ( | MetricsMode | mode | ) |

  | set the current metrics mode employed by the Window Parameters:
  | mode | One of the values of the MectricsMode enumerated type, that describes the metrics mode to be used by the Window.
Returns: Nothing

void CEGUI::Window::setMinimumSize | ( | const Size & | sz | ) |

  | Set the minimum size for this window. Parameters:
  | sz | Size object describing the minimum size for the window. For absolute metrics, the Size values are in screen pixels, for relative metrics the Size values are relative to the display size.

void CEGUI::Window::setModalState | ( | bool | state | ) |

  | Set the modal state for this Window. Parameters:
  | state | Boolean value defining if this Window should be the modal target. If true, this Window will be activated and set as the modal target. If false, the modal target will be cleared if this Window is currently the modal target.
Returns: Nothing.

void CEGUI::Window::setMouseAutoRepeatEnabled | ( | bool | setting | ) |

  | Set whether mouse button down event autorepeat is enabled for this window. Parameters:
  | setting | true to enable autorepeat of mouse button down events. false to disable autorepeat of mouse button down events.
Returns: Nothing.

void CEGUI::Window::setMouseCursor | ( | const String & | imageset,
|  | const String & | image_name
| ) |

  | Set the mouse cursor image to be used when the mouse enters this window. Parameters:
  | imageset | String object that contains the name of the Imageset that contains the image to be used.
  | image_name | String object that contains the name of the Image on imageset that is to be used.
  Returns: Nothing. Exceptions:
  | UnknownObjectException | thrown if imageset is not known, or if imageset contains no Image named image_name.

void CEGUI::Window::setMouseCursor | ( | MouseCursorImage | image | ) | `[inline]`

  | Set the mouse cursor image to be used when the mouse enters this window. Parameters:
  | image | One of the MouseCursorImage enumerated values.
Returns: Nothing.

void CEGUI::Window::setMouseCursor | ( | const Image * | image | ) | `[inline]`

  | Set the mouse cursor image to be used when the mouse enters this window. Parameters:
  | image | Pointer to the Image object to use as the mouse cursor image when the mouse enters the area for this Window.
Returns: Nothing.

void CEGUI::Window::setParent | ( | Window * | parent | ) | `[protected]`

  | Set the parent window for this window object. Parameters:
  | parent | Pointer to a Window object that is to be assigned as the parent to this Window.
Returns: Nothing

void CEGUI::Window::setPosition | ( | MetricsMode | mode,
|  | const Point & | position
| ) |

  | set the position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | position | Point object that describes the position of the Window relative to it's parent, using the specified MetricsMode.
Returns: Nothing

void CEGUI::Window::setPosition | ( | const Point & | position | ) |

  | Set the current position of the Window. Interpretation of the input value position is dependant upon the current metrics system set for the Window. Parameters:
  | position | Point object that describes the new postion of the Window, in units consistent with the current metrics mode.
Returns: Nothing

void CEGUI::Window::setRect | ( | MetricsMode | mode,
|  | const Rect & | area
| ) |

  | set the Rect that describes the Window area using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | area | Rect object that describes the area to be covered by the Window using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setRestoreCapture | ( | bool | setting | ) |

  | Set whether this window will remember and restore the previous window that had inputs captured. Parameters:
  | setting | true: The window will remember and restore the previous capture window. The CaptureLost event is not fired on the previous window when this window steals input capture. When this window releases capture, the old capture window is silently restored.
false: Input capture works as normal, each window losing capture is signalled via CaptureLost, and upon the final release of capture, no previous setting is restored (this is the default 'normal' behaviour). Returns: Nothing

void CEGUI::Window::setRiseOnClickEnabled | ( | bool | setting | ) | `[inline]`

  | Set whether this window will rise to the top of the z-order when clicked with the left mouse button. Parameters:
  | setting | true if the window should come to the top of other windows when the left mouse button is pushed within its area. false if the window should not change z-order position when the left mouse button is pushed within its area.
Returns: Nothing.

void CEGUI::Window::setSize | ( | MetricsMode | mode,
|  | const Size & | size
| ) |

  | set the size of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | size | Size object that describes the dimensions of the Window using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setSize | ( | const Size & | size | ) |

  | Set the current size of the Window. Interpretation of the input value size is dependant upon the current metrics system set for the Window. Parameters:
  | size | Size object that describes the new dimensions for the window, in units consistent with whatever metrics mode is in operation.
Returns: Nothing

void CEGUI::Window::setText | ( | const String & | text | ) |

  | Set the current text string for the Window. Parameters:
  | text | String object containing the text that is to be set as the Window text.
Returns: Nothing

void CEGUI::Window::setTooltip | ( | Tooltip * | tooltip | ) |

  | Set the custom Tooltip object for this Window. This value may be NULL to indicate that the Window should use the system default Tooltip object. Parameters:
  | tooltip | Pointer to a valid Tooltip based object which should be used as the tooltip for this Window, or NULL to indicate that the Window should use the system default Tooltip object. Note that when passing a pointer to a Tooltip object, ownership of the Tooltip does not pass to this Window object.
Returns: Nothing.

void CEGUI::Window::setTooltipText | ( | const String & | tip | ) |

  | Set the tooltip text for this window. Parameters:
  | tip | String object holding the text to be displayed in the tooltip for this Window.
Returns: Nothing.

void CEGUI::Window::setTooltipType | ( | const String & | tooltipType | ) |

  | Set the custom Tooltip to be used by this Window by specifying a Window type. The Window will internally attempt to create an instance of the specified window type (which must be derived from the base Tooltip class). If the Tooltip creation fails, the error is logged and the Window will revert to using either the existing custom Tooltip or the system default Tooltip. Parameters:
  | tooltipType | String object holding the name of the Tooltip based Window type which should be used as the Tooltip for this Window.
Returns: Nothing.

void CEGUI::Window::setUserData | ( | void * | user_data | ) | `[inline]`

  | Set the user data set for this Window. Each Window can have some client assigned data attached to it, this data is not used by the GUI system in any way. Interpretation of the data is entirely application specific. Parameters:
  | user_data | pointer to the user data that is to be set for this window.
Returns: Nothing.

void CEGUI::Window::setUserString | ( | const String & | name,
|  | const String & | value
| ) |

  | Sets the value a named user string, creating it as required. Parameters:
  | name | String object holding the name of the string to be returned.
  | value | String object holding the value to be assigned to the user string.
Returns: Nothing.

void CEGUI::Window::setVerticalAlignment | ( | const VerticalAlignment | alignment | ) |

  | Set the vertical alignment. Modifies the vertical alignment for the window. This setting affects how the windows position is interpreted relative to its parent. Parameters:
  | alignment | One of the VerticalAlignment enumerated values.
Returns: Nothing.

void CEGUI::Window::setVisible | ( | bool | setting | ) |

  | Set whether the Window is visible or hidden. Parameters:
  | setting | true to make the Window visible, or false to make the Window hidden
Returns: Nothing

void CEGUI::Window::setWantsMultiClickEvents | ( | bool | setting | ) |

  | Set whether this window will receive multi-click events or multiple 'down' events instead. Parameters:
  | setting | true if the Window will receive double-click and triple-click events. false if the Window will receive multiple mouse button down events instead of double/triple click events.
Returns: Nothing.

void CEGUI::Window::setWidth | ( | MetricsMode | mode,
|  | float | width
| ) |

  | set the width of the Window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | width | float value that specifies the width of the Window using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setWidth | ( | float | width | ) |

  | Set the current width of the Window. Interpretation of the input value width is dependant upon the current metrics system set for the Window. Parameters:
  | width | float value that specifies the new width for the window, in units consistent with whatever metrics mode is in operation.
Returns: Nothing

void CEGUI::Window::setWindowArea | ( | const URect & | area | ) |

  | Set the window area. Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | area | URect describing the new area rectangle of the window area.

void CEGUI::Window::setWindowArea | ( | const UVector2 & | pos,
|  | const UVector2 & | size
| ) |

  | Set the window area. Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | pos | UVector2 describing the new position (top-left corner) of the window area.
  | size | UVector2 describing the new size of the window area.

void CEGUI::Window::setWindowArea | ( | const UDim & | xpos,
|  | const UDim & | ypos,
|  | const UDim & | width,
|  | const UDim & | height
| ) |

  | Set the window area. Sets the area occupied by this window. The defined area is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | xpos | UDim describing the new x co-ordinate (left edge) of the window area.
  | ypos | UDim describing the new y co-ordinate (top-edge) of the window area.
  | width | UDim describing the new width of the window area.
  | height | UDim describing the new height of the window area.

void CEGUI::Window::setWindowArea_impl | ( | const UVector2 & | pos,
|  | const UVector2 & | size,
|  | bool | topLeftSizing = `false`,
|  | bool | fireEvents = `true`
| ) | `[protected]`

| Implementation method to modify window area while correctly applying min / max size processing, and firing any appropriate events. /note This is the implementation function for setting size and position. In order to simplify area management, from this point on, all modifications to window size and position (area rect) should come through here. /param pos UVector2 object describing the new area position. /param size UVector2 object describing the new area size. /param topLeftSizing true to indicate the the operation is a sizing operation on the top and/or left edges of the area, and so window movement should be inhibited if size is at max or min. false to indicate the operation is not a strict sizing operation on the top and/or left edges and that the window position may change as required /param fireEvents true if events should be fired as normal. false to inhibit firing of events (required, for example, if you need to call this from the onSize/onMove handlers).

void CEGUI::Window::setWindowHeight | ( | const UDim & | height | ) |

  | Set the window's height. Sets the height of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | height | UDim describing the new height of the window area.

void CEGUI::Window::setWindowMaxSize | ( | const UVector2 & | size | ) |

  | Set the window's maximum size. Sets the maximum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | size | UVector2 describing the new maximum size of the window area.

void CEGUI::Window::setWindowMinSize | ( | const UVector2 & | size | ) |

  | Set the window's minimum size. Sets the minimum size that this windows area may occupy (whether size changes occur by user interaction, general system operation, or by direct setting by client code). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | size | UVector2 describing the new minimum size of the window area.

void CEGUI::Window::setWindowPosition | ( | const UVector2 & | pos | ) |

  | Set the window's position. Sets the position of the area occupied by this window. The position is offset from the top-left corner of this windows parent window or from the top-left corner of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | pos | UVector2 describing the new position (top-left corner) of the window area.

void CEGUI::Window::setWindowSize | ( | const UVector2 & | size | ) |

  | Set the window's size. Sets the size of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | size | UVector2 describing the new size of the window area.

void CEGUI::Window::setWindowWidth | ( | const UDim & | width | ) |

  | Set the window's width. Sets the width of the area occupied by this window. Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | width | UDim describing the new width of the window area.

void CEGUI::Window::setWindowXPosition | ( | const UDim & | x | ) |

  | Set the window's X position. Sets the x position (left edge) of the area occupied by this window. The position is offset from the left edge of this windows parent window or from the left edge of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | x | UDim describing the new x position of the window area.

void CEGUI::Window::setWindowYPosition | ( | const UDim & | y | ) |

  | Set the window's Y position. Sets the y position (top edge) of the area occupied by this window. The position is offset from the top edge of this windows parent window or from the top edge of the display if this window has no parent (i.e. it is the root window). Note: This method makes use of "Unified Dimensions". These contain both parent relative and absolute pixel components, which are used in determining the final value used. Parameters:
  | y | UDim describing the new y position of the window area.

void CEGUI::Window::setXPosition | ( | MetricsMode | mode,
|  | float | x
| ) |

  | set the x position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | x | float value that specifies the x position of the Window relative to it's parent, using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setXPosition | ( | float | x | ) |

  | Set the current 'x' position of the Window. Interpretation of the input value x is dependant upon the current metrics system set for the Window. Parameters:
  | x | float value that specifies the new x postion of the Window, in units consistent with the current metrics mode.
Returns: Nothing

void CEGUI::Window::setYPosition | ( | MetricsMode | mode,
|  | float | y
| ) |

  | set the y position of the window using the specified metrics system. Parameters:
  | mode | One of the MetricsMode enumerated values specifying the metrics system to be used for the return value.
  | y | float value that specifies the y position of the Window relative to it's parent, using the specified MetricsMode.
Returns: Nothing.

void CEGUI::Window::setYPosition | ( | float | y | ) |

  | Set the current 'y' position of the Window. Interpretation of the input value y is dependant upon the current metrics system set for the Window. Parameters:
  | y | float value that specifies the new y postion of the Window, in units consistent with the current metrics mode.
Returns: Nothing

void CEGUI::Window::setZOrderingEnabled | ( | bool | setting | ) |

  | Set whether z-order changes are enabled or disabled for this Window. Parameters:
  | setting | true if z-order changes are enabled for this window. moveToFront/moveToBack work normally as expected. false: z-order changes are disabled for this window. moveToFront/moveToBack are ignored for this window.
Returns: Nothing.

void CEGUI::Window::show | ( | void |  | ) | `[inline]`

| show the Window Returns: Nothing

bool CEGUI::Window::testClassName | ( | const String & | class_name | ) | const`[inline]`

  | Return whether this window was inherited from the given class name at some point in the inheritance heirarchy. Parameters:
  | class_name | The class name that is to be checked.
Returns: true if this window was inherited from class_name. false if not.

virtual bool CEGUI::Window::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

  | Return whether this window was inherited from the given class name at some point in the inheritance heirarchy. Parameters:
  | class_name | The class name that is to be checked.
Returns: true if this window was inherited from class_name. false if not. Reimplemented in CEGUI::ButtonBase, CEGUI::Checkbox, CEGUI::Combobox, CEGUI::ComboDropList, CEGUI::DragContainer, CEGUI::Editbox, CEGUI::FrameWindow, CEGUI::GUISheet, CEGUI::ItemEntry, CEGUI::ItemListBase, CEGUI::Listbox, CEGUI::ListHeader, CEGUI::ListHeaderSegment, CEGUI::Menubar, CEGUI::MenuBase, CEGUI::MenuItem, CEGUI::MultiColumnList, CEGUI::MultiLineEditbox, CEGUI::PopupMenu, CEGUI::ProgressBar, CEGUI::PushButton, CEGUI::RadioButton, CEGUI::ScrollablePane, CEGUI::Scrollbar, CEGUI::ScrolledContainer, CEGUI::Slider, CEGUI::Spinner, CEGUI::Static, CEGUI::StaticImage, CEGUI::StaticText, CEGUI::TabButton, CEGUI::TabControl, CEGUI::TabPane, CEGUI::TextItem, CEGUI::Thumb, CEGUI::Titlebar, and CEGUI::Tooltip.

Rect CEGUI::Window::unifiedToAbsolute | ( | const URect & | val | ) | const

  | Convert the given area from unfied to absolute metrics. Parameters:
  | val | URect object describing the area specified in unified dimensions relative to this Window.
Returns: A Rect object describing an absolute metric area that is equivalent to val, given the Window objects current size.

Vector2 CEGUI::Window::unifiedToAbsolute | ( | const UVector2 & | val | ) | const

  | Convert the given UVector2 value from unified to absolute metrics. Parameters:
  | val | UVector2 object that describes a position specified in unified dimensions relative to this Window (so {{0, 0}, {0, 0}) is this windows top-left corner).
Returns: A Vector2 object describing a absolute metric point that is equivalent to val, given the Window objects current size.

float CEGUI::Window::unifiedToAbsoluteX | ( | const UDim & | val | ) | const

  | Convert the given X co-ordinate from unified to absolute metrics. Parameters:
  | val | X co-ordinate specified as a UDim relative to this Window (so {0, 0} is this windows left edge).
Returns: An absolute metric value that is equivalent to val, given the Window objects current width.

float CEGUI::Window::unifiedToAbsoluteY | ( | const UDim & | val | ) | const

  | Convert the given Y co-ordinate from unified to absolute metrics. Parameters:
  | val | Y co-ordinate specified in as a UDim relative to this Window (so {0, 0} is this windows top edge).
Returns: An absolute metric value that is equivalent to val, given the Window objects current height.

Rect CEGUI::Window::unifiedToRelative | ( | const URect & | val | ) | const

  | Convert the given area from unfied to relative metrics. Parameters:
  | val | URect object describing the area specified in unified dimensions relative to this Window.
Returns: A Rect object describing a relative metric area that is equivalent to val, given the Window objects current size.

Vector2 CEGUI::Window::unifiedToRelative | ( | const UVector2 & | val | ) | const

  | Convert the given UVector2 value from unified to relative metrics. Parameters:
  | val | UVector2 object that describes a position specified in unified dimensions relative to this Window (so {{0, 0}, {0, 0}) is this windows top-left corner).
Returns: A Vector2 object describing a relative metric point that is equivalent to val, given the Window objects current size.

float CEGUI::Window::unifiedToRelativeX | ( | const UDim & | val | ) | const

  | Convert the given X co-ordinate from unified to relative metrics. Parameters:
  | val | X co-ordinate specified as a UDim relative to this Window (so {0, 0} is this windows left edge).
Returns: A relative metric value that is equivalent to val, given the Window objects current width.

float CEGUI::Window::unifiedToRelativeY | ( | const UDim & | val | ) | const

  | Convert the given Y co-ordinate from unified to relative metrics. Parameters:
  | val | Y co-ordinate specified in as a UDim relative to this Window (so {0, 0} is this windows top edge).
Returns: A relative metric value that is equivalent to val, given the Window objects current height.

void CEGUI::Window::update | ( | float | elapsed | ) |

  | Cause window to update itself and any attached children. Client code does not need to call this method; to ensure full, and proper updates, call the injectTimePulse methodname method provided by the System class. Note: The update order is such that 'this' window is updated prior to any child windows, this is so that child windows that access the parent in their update code get the correct updated state. Parameters:
  | elapsed | float value indicating the number of seconds passed since the last update.
Returns: Nothing.

void CEGUI::Window::updateSelf | ( | float | elapsed | ) | `[protected, virtual]`

  | Perform actual update processing for this Window. Parameters:
  | elapsed | float value indicating the number of seconds elapsed since the last update call.
Returns: Nothing. Reimplemented in CEGUI::PopupMenu, and CEGUI::Tooltip.

bool CEGUI::Window::wantsMultiClickEvents | ( | void |  | ) | const

| Return whether this window will receive multi-click events or multiple 'down' events instead. Returns: true if the Window will receive double-click and triple-click events. false if the Window will receive multiple mouse button down events instead of double/triple click events.

Rect CEGUI::Window::windowToScreen | ( | const URect & | rect | ) | const

  | Convert a window area, specified as a URect, to a screen area. Parameters:
  | rect | URect object describing the area to be converted
Returns: Rect object describing a screen area that is equivalent to window area rect.

Vector2 CEGUI::Window::windowToScreen | ( | const UVector2 & | vec | ) | const

  | Convert a window co-ordinate point, specified as a UVector2, to a screen relative pixel co-ordinate point. Parameters:
  | vec | UVector2 object describing the point to be converted
Returns: Vector2 object describing a screen co-ordinate position that is equivalent to window based UVector2 vec.

Rect CEGUI::Window::windowToScreen | ( | const Rect & | rect | ) | const

  | Convert a window area, specified in whichever metrics mode is active, to a screen area. Parameters:
  | rect | Rect object describing the area to be converted
Returns: Rect object describing a screen area that is equivalent to window area rect.

Size CEGUI::Window::windowToScreen | ( | const Size & | sze | ) | const

  | Convert a window size value, specified in whichever metrics mode is active, to a size in pixels. Parameters:
  | sze | Size object describing the size to be converted
Returns: Size object describing describing a size in pixels that is equivalent to the window based size sze.

Point CEGUI::Window::windowToScreen | ( | const Point & | pt | ) | const

  | Convert a window co-ordinate position, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate position. Parameters:
  | pt | Point object describing the position to be converted
Returns: Point object describing a screen co-ordinate position that is equivalent to window co-ordinate position pt.

float CEGUI::Window::windowToScreenX | ( | const UDim & | x | ) | const

  | Convert a window co-ordinate value, specified as a UDim, to a screen relative pixel co-ordinate. Parameters:
  | x | UDim x co-ordinate value to be converted
Returns: float value describing a pixel screen co-ordinate that is equivalent to window UDim co-ordinate x.

float CEGUI::Window::windowToScreenX | ( | float | x | ) | const

  | Convert a window co-ordinate value, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate. Parameters:
  | x | x co-ordinate value to be converted
Returns: float value describing a pixel screen co-ordinate that is equivalent to window co-ordinate x.

float CEGUI::Window::windowToScreenY | ( | const UDim & | y | ) | const

  | Convert a window co-ordinate value, specified as a UDim, to a screen relative pixel co-ordinate. Parameters:
  | y | UDim y co-ordinate value to be converted
Returns: float value describing a screen co-ordinate that is equivalent to window UDim co-ordinate y.

float CEGUI::Window::windowToScreenY | ( | float | y | ) | const

  | Convert a window co-ordinate value, specified in whichever metrics mode is active, to a screen relative pixel co-ordinate. Parameters:
  | y | y co-ordinate value to be converted
Returns: float value describing a screen co-ordinate that is equivalent to window co-ordinate y.

void CEGUI::Window::writeXMLToStream | ( | OutStream & | out_stream | ) | const`[virtual]`

  | Writes an xml representation of this window object to out_stream. Parameters:
  | out_stream | Stream where xml data should be output.
Returns: Nothing.